	module abort_bugs6
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!  Purpose:
!
!     This module provides a graceful way for the model to exit when
!       it crashes.
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	use kinds
        implicit none
        private

#ifdef fluxcorrectedtransport
! public member functions
        public ::             &
           abort_code6

!*************************************************************************

        contains

!*************************************************************************

!======================================================================
! BEGINNING OF ABORT_CODE
!======================================================================
        subroutine abort_code6(exit_message)

        character (*), intent(in), optional :: &
              exit_message ! message to print before stopping

#ifdef mpi
        include 'mpif.h'
        integer (kind=int_kind) :: ierrorcode=0, ierror=0

        write (6,'(a14)') '!!!!exiting...'
        if(present(exit_message)) then
           write (6,*) exit_message
        endif
        call MPI_ABORT(MPI_COMM_world, ierrorcode, ierror)

#else
        write (6,'(a14)') '!!!!exiting...'
        if(present(exit_message)) then
           write (6,*) exit_message
        endif
        stop
#endif

        end subroutine abort_code6
!======================================================================
! END OF ABORT_CODE
!======================================================================
#endif
	end module abort_bugs6
