!-----------------------------------------------------------------------

 subroutine eau_logint                    &
                (len1 , len , nlm , lbeg, &  
                 lend , xil , xil2        &
                )

 use kinds
 use physical_parameters
 
 implicit none
      
!-----------------------------------------------------------------------

! logint2 does a logarithmic interpolation of variables located in the
! middle of a layer to the bottom edge of that layer in the stratosphere
! only.
! Laura D. Fowler (slikrock/ 01-05-98).

! send comments to laura@slikrock.atmos.colostate.edu

! modifications:
! * Modified the declarations of variables and arrays to adapt the code
! from bugs4 to bugs5.
! Laura D. Fowler/slikrock (03-01-01).

! subroutines called:
!     none.

! argument list variables:
! input arguments:
! ----------------

 integer (kind=int_kind) :: &
   len1, & ! length of total or sub domain.
   len, &  ! length of sub domain.
   nlm, &  ! number of layers.
   lbeg, & ! indice of top stratospheric layer.
   lend    ! indice of bottom stratospheric layer.

 real (kind=dbl_kind), intent(in), dimension(len1,nlm) :: &
   xil     ! layer variable.
     
! output arguments:
! -----------------

 real (kind=dbl_kind), intent(out), dimension(len,nlm) :: &
   xil2    ! Level variable.
     
! other variables:

 integer (kind=int_kind) :: i,l

 real (kind=dbl_kind), dimension(len) :: diffx

!-----------------------------------------------------------------------

 do l = lbeg, lend
    do i = 1, len
       if (xil(i,l) /= c0 .and. xil(i,l+1) /= c0) then
          xil2(i,l) = log(xil(i,l)/xil(i,l+1))
       else
          xil2(i,l) = c0
       endif   
       diffx(i) = xil(i,l)-xil(i,l+1)
       if (diffx(i) /= c0) then
          xil2(i,l) = xil2(i,l)*xil(i,l)*xil(i,l+1)/diffx(i)
       else
          xil2(i,l) = xil(i,l)
       endif
    enddo
 enddo            

 end subroutine eau_logint

!-----------------------------------------------------------------------
