


	subroutine get_bcdata(iunit,phis,f,area,im,jm,km)

        implicit none
        integer  i,j,k,n
        integer  im,jm,km,nt,iunit
        real, dimension(im,jm) :: phis,f,area
	read(iunit) ((phis(i,j),i=1,im),j=1,jm)
	read(iunit) ((f(i,j),i=1,im),j=1,jm)
!	read(iunit) ((area(i,j),i=1,im),j=1,jm)
	return
	end



        subroutine get_data(iunit,		&
      			ps,			&
			pb,			&
      			eta,			&
      			div,			&
      			psi,			&
      			chi,			&
      			th,			&
      			ke,			&
      			tr,			&
      			im,			&
      			jm,			&
      			km,			&
      			nt,psc)


	implicit none
	integer  i,j,k,n
	integer  im,jm,km,nt,iunit
	real, dimension(im,jm) :: ps,pb,blent,blmb,leak
	real, dimension(im,jm,km) :: eta,div,psi,chi,th,sdot,phi,ke
	real, dimension(im,jm,km,nt) :: tr
	real, dimension(im,jm,km) :: work
	logical psc


	read(iunit) ((ps(i,j),i=1,im),j=1,jm)
	write(6,*) maxval(ps)
 	read(iunit) ((pb(i,j),i=1,im),j=1,jm)
	do k=1,km
	  read(iunit) ((eta(i,j,k),i=1,im),j=1,jm)
	enddo
        do k=1,km
          read(iunit) ((div(i,j,k),i=1,im),j=1,jm)
        enddo
        do k=1,km
          read(iunit) ((th(i,j,k),i=1,im),j=1,jm)
        enddo
        do n=1,nt
        do k=1,km
          read(iunit) ((tr(i,j,k,n),i=1,im),j=1,jm)
        enddo
        enddo
        do k=1,km
          read(iunit) ((ke(i,j,k),i=1,im),j=1,jm)
        enddo
        do k=1,km
          read(iunit) ((sdot(i,j,k),i=1,im),j=1,jm)
        enddo
        do k=1,km
          read(iunit) ((psi(i,j,k),i=1,im),j=1,jm)
        enddo
        do k=1,km
          read(iunit) ((chi(i,j,k),i=1,im),j=1,jm)
        enddo
        do k=1,2
          read(iunit) ((work(i,j,k),i=1,im),j=1,jm)
        enddo
	do n=1,13
	do k=1,km
          read(iunit) ((work(i,j,k),i=1,im),j=1,jm)
        enddo
	enddo
        do k=1,4
          read(iunit) ((work(i,j,k),i=1,im),j=1,jm)
        enddo


	return
	end
 
 
 
 
	subroutine get_vel_lat_lon(psi,chi,ur,vr,ud,vd,im,jm,km)
 
	implicit none
	integer im,jm,km
	integer i,j,k
	real, dimension(im,jm,km), intent(in) :: psi,chi
	real, dimension(im,jm,km), intent(out) :: ur,vr,ud,vd
	real, dimension(im,jm,km) :: tmp1, tmp2, invdx, invdy
	real, dimension(jm) :: lat
	real pi, drad, a, dtr


	pi=4.0*atan(1.0)
	drad=2*pi/im
	a=6.371e6
	dtr=pi/180.0

	do j=1,jm
	lat(j) = -pi/2 + drad/2.0 + drad*(j-1)
	enddo

	do j=1,jm
	invdx(:,j,:) = 1.0/(a*2*drad*cos(lat(j)))
        invdy(:,j,:) = 1.0/(a*2*drad)
	enddo

	tmp1=cshift(psi,dim=1,shift=+1)
	tmp2=cshift(psi,dim=1,shift=-1)
	vr=+(tmp1-tmp2)*invdx

	tmp1=cshift(psi,dim=2,shift=+1)
	tmp2=cshift(psi,dim=2,shift=-1)
	ur=-(tmp1-tmp2)*invdy

	tmp1=cshift(chi,dim=1,shift=+1)
	tmp2=cshift(chi,dim=1,shift=-1)
	ud=+(tmp1-tmp2)*invdx

	tmp1=cshift(chi,dim=2,shift=+1)
	tmp2=cshift(chi,dim=2,shift=-1)
	vd=+(tmp1-tmp2)*invdy
 
	ur(:, 1,:) = 0.0
	vr(:, 1,:) = 0.0
	ud(:, 1,:) = 0.0
	vd(:, 1,:) = 0.0
        ur(:,jm,:) = 0.0
        vr(:,jm,:) = 0.0
        ud(:,jm,:) = 0.0
        vd(:,jm,:) = 0.0

	return
	end



	subroutine write_data_3d(iunit,xin,im,jm,km)
	implicit none
	integer im,jm,km,iunit,k
	real, dimension(im,jm,km) :: xin
	do k=1,km
	call write_data_2d(iunit,xin(1,1,k),im,jm)
	enddo
	return
	end




        subroutine write_data_2d(iunit,xin,im,jm)
        implicit none
        integer im,jm,iunit,i,j
        real, dimension(im,jm) :: xin
	write(iunit) ((xin(i,j),i=1,im),j=1,jm)
	return
	end




	subroutine convert_to_static_temp(th,pressure,t,im,jm,km)
        implicit none
        integer im,jm,km,iunit,i,j,k
	real, parameter :: pref=1.0e5, kappa=0.28571
        real, dimension(im,jm,km), intent(in) :: th,pressure
        real, dimension(im,jm,km), intent(out) :: t
	t(:,:,:) = th(:,:,:)*(pressure(:,:,:)/pref)**kappa
	return
	end



	subroutine write_init(eta,div,th,ps,tr,pb,im,jm,km,nt)
        implicit none
        integer im,jm,km,iunit,i,j,k,nt,l
	real, dimension(im,jm), intent(in) :: ps,pb
	real, dimension(im,jm,km), intent(in) :: eta,div,th
	real, dimension(im,jm,km,nt), intent(in) :: tr

	write(85) (((eta(i,j,k),i=1,im),j=1,jm),k=1,km)
	write(85) (((div(i,j,k),i=1,im),j=1,jm),k=1,km)
	write(85) (((th(i,j,k),i=1,im),j=1,jm),k=1,km)
	write(85) ((ps(i,j),i=1,im),j=1,jm)
	do l=1,nt
	write(85) (((tr(i,j,k,l),i=1,im),j=1,jm),k=1,km)
	enddo
	write(85) ((pb(i,j),i=1,im),j=1,jm)
	return
	end



        subroutine get_pressure(ps,pb,sig,psc,gsc_ns,gsc,ptop,    &
		pinterface,pressure,im,jm,km)

        implicit none
        integer im,jm,km,k
        real, dimension(im,jm), intent(in) :: ps,pb
        real, dimension(im,jm,km), intent(out) :: pressure
        real, dimension(km), intent(in) :: sig
        real, dimension(im,jm,km) :: tmp
        real ptop,pinterface
        logical psc,gsc_ns,gsc


        if(psc) then
          do k=1,km
          pressure(:,:,k) = (ps(:,:)-ptop)*sig(k) + ptop
          enddo
        endif

        if(gsc_ns) then
         do k=1,km
          if(sig(k).gt.1.0) then
            pressure(:,:,k) = (ps(:,:) - pb(:,:)) *              &
		 (sig(k)-1.0) + pb(:,:)
          else
            pressure(:,:,k) = (pb(:,:) - ptop) *                 &
		sig(k) + ptop
          endif
         enddo
        endif

        if(gsc) then
          do k=1,km
           if(sig(k).lt.0.0) then
              pressure(:,:,k) = (pinterface - ptop) * sig(k)      &
		+ pinterface
           elseif(sig(k).gt.1.0) then
              pressure(:,:,k) = (ps(:,:) - pb(:,:)) *             &
		(sig(k)-1.0) + pb(:,:)
           else
              pressure(:,:,k) = (pb(:,:) - pinterface) * sig(k)   &
		+ pinterface
           endif
          enddo
        endif

! invert pressure
        do k=1,km
        tmp(:,:,k) = pressure(:,:,km+1-k)
        enddo
        pressure = tmp

        return
        end

