c------------------------------------------------------------------------------

      subroutine clcf(pl,pl2,tl,cw0,cw1,ci0,ci1,ri0,ri1,ctot0,ctot1
     *,             pc,cldpc,cld,clu,cldcw,cldci,nlen,nlm,nls,len)

      use kinds

      implicit none

c------------------------------------------------------------------------------
c     This subroutine computes the planetary boundary layer,large-scale sa-
c     turation and anvil cloud fractional amounts. Clouds cannot form 
c     in the stratosphere.

c     Laura D. Fowler/stratus (03-25-93)

c     Modifications:
c     - Removed the logicals DORAD and ANVILS, as well as the code that
c       went with them.
c       Laura D. Fowler (04-03-97).

c------------------------------------------------------------------------------

      INTEGER (kind=int_kind) ::
     *       nlen,nlm,len,nls
      REAL (kind=dbl_kind) ::
     *       pcblk
      REAL (kind=dbl_kind) ::
     *       pc(nlen), cldpc(nlen)
      REAL (kind=dbl_kind) ::
     *       pl(nlen,nlm)  ,tl(nlen,nlm)   ,cw0(nlen,nlm)
     *,      cw1(nlen,nlm)  ,ci0(nlen,nlm)   ,ci1(nlen,nlm)
     *,      ri0(nlen,nlm)  ,ri1(nlen,nlm)   ,cld(nlen,nlm) 
     *,      clu(nlen,nlm) ,cldcw(nlen,nlm),cldci(nlen,nlm)      
     *,      ctot0(nlen,nlm),ctot1(nlen,nlm)
      REAL (kind=dbl_kind) ::
     *       pl2(nlen,nlm+1)

      INTEGER (kind=int_kind) ::
     *       i,l,nlmm1,nlmp1,nlsp1
      data pcblk /.08/

      nlmm1 = nlm-1
      nlmp1 = nlm+1
      nlsp1 = nls+1

c---- 0. Initialization:
      do l = 1, nlm
          do i = 1, len
            cld(i,l)   = 0.
            clu(i,l)   = 0.
            cldcw(i,l) = 0.
            cldci(i,l) = 0.
         enddo
      enddo

c---- 1. large-scale saturation + PBL cloud fractions:
      do l = nlsp1, nlmm1
         do i = 1, len
            if(ctot0(i,l).gt.0.) clu(i,l) = 1.
            if(ctot1(i,l).gt.0.) cld(i,l) = 1.
            if((cw0(i,l)+cw1(i,l)).gt.0.) cldcw(i,l) = 1.
            if((ci0(i,l)+ci1(i,l)+ri1(i,l)+ri0(i,l)).gt.0.)
     +          cldci(i,l) = 1.
         enddo
      enddo
      do i = 1, len
          cld(i,nlm) = cldpc(i)
c         if(pc(i)-pl2(i,nlm).gt.0.1_dbl_kind) cld(i,nlm) = 1.0
c         cld(i,nlm) = (pc(i) - pl2(i,nlm))* pcblk
c         cld(i,nlm) = min(1.0_dbl_kind,cld(i,nlm))
c         cld(i,nlm) = cld(i,nlm)*(pc(i)-pl2(i,nlm))
c     +                 /(pl2(i,nlmp1)-pl2(i,nlm))
      enddo        

      return
      end
