C--------------------

      SUBROUTINE CLEAR( dooz, SQRT3,SCOSZ,COSMAG
     *,       SL,ACLR,DSCLR,dsclrtom,OZALE,RLO,RLG,SWALE
     *,       RVBL,RVDL,RNBL,RNDL,RSURFN,AGV,RSURFV,TR1
     *,       NSOL,NSLMP1,NSOLNP, len, imnnp, imlmp1, nlmp1)

c	Calculates atmospheric heating rate due to clear sky.  Performed
c	at all points where sun is up.

c	Modifications:
c		- replaced gcmlib calls with inlined code.  kwitt 9/27/92
c               - replaced common block work with argument list
c                         d.d.11/09/92

C--------------------

      use kinds

      IMPLICIT none

C    Declare argument list arrays

      logical (kind=log_kind) ::  dooz
      integer (kind=int_kind) ::  len, imnnp, imlmp1, nlmp1
      REAL (kind=dbl_kind) ::
     *        SQRT3,SCOSZ(len),COSMAG(len)
     *,       SL(len),ACLR(IMLMP1),DSCLR(len)
     *,       OZALE(IMNNP),RLO(len),RLG(len),SWALE(IMNNP)
     *,       RVBL(len),RVDL(len),RNBL(len),RNDL(len)
     *,       RSURFN(len),AGV(len),RSURFV(len),TR1(len)
     *,       dsclrtom(len)
      integer (kind=int_kind) :: NSOL,NSLMP1,NSOLNP


C    Declare local arrays

      REAL (kind=dbl_kind) ::
     *     FK(5),XK(5),AVBL(len)
     *,    DEN(IMLMP1),VP(IMNNP),eo(IMLMP1)
     *,    W(IMNNP),DN(IMNNP),UP(IMNNP)
      integer (kind=int_kind) ::
     *     lp, i, l, l0, l1, ik, nnp

      DATA FK/0.107, 0.104, 0.073, 0.044, 0.025/
      DATA XK/0.005, 0.041, 0.416, 4.752, 72.459/

      LP = nLMP1 * NSOL
      nnp = nlmp1+1

      DO I=1,NSOL
         SL(I) = 0.
         DN(I) = 0.
      ENDDO

      DO I=1,NSLMP1
         ACLR(I) = 0.
      ENDDO

      DO L=1,nLMP1
         L0 = (L-1) * NSOL
         DO I=1,NSOL
            DEN(L0+I) = SCOSZ(I)
         ENDDO
      ENDDO

      IF (DOOZ) THEN
         DO L=2,nnp
            L0 = (L-2) * NSOL
            L1 = (L-1) * NSOL
            DO I=1,NSOL
               W(L0+I) = OZALE(L1+I) * COSMAG(I)
            ENDDO
         ENDDO

         DO I=1,NSLMP1
            eo(I) = 103.63 * W(I)
            eo(I) = eo(I) * eo(I) * eo(I)
            VP(I) = 1. + 138.57 * W(I)

            DN(NSOL+I) = 0.02118 * W(I) / (1. + 0.042 * W(I) +
     *         0.000323 * W(I) * W(I)) + 1.08173 * W(I) /
     *         (vp(i) ** .805) + 0.0658 * W(I) / (1. + eo(I))

C        COMPUTE OZONE HEATING ON THE WAY DOWN

            ACLR(I) = (DN(NSOL+I) - DN(I)) * DEN(I)
     
         ENDDO
      ELSE
         DO I=1,NSOL
            DN(LP+I) = 0.
         ENDDO
      ENDIF

C     DOWNFLUX AND GROUND ABSORPTION FOR LAMDA LESS THAN 0.7 MICRONS
C     AS ABOVE BUT FOR LAMBDA BETWEEN 0.7 AND 0.9 MICRONS

      DO I=1,NSOL
         SL(I) = 0.5 - DN(LP+I)
         RVBL(I) = SL(I) * TR1(I) * SCOSZ(I)
         AVBL(I) = (1.0 - RSURFV(I)) * RVBL(I)
         SL(I) = (1. - RLG(I)) * SCOSZ(I) * SL(I)
         RVDL(I) = (SL(I) - AVBL(I)) / (1. - AGV(I))
         RNBL(I) = 0.147 * SCOSZ(I)
         RNDL(I) = 0.
         SL(I) = SL(I) + RNBL(I) * (1. - RSURFN(I))
      ENDDO

      IF (DOOZ) THEN
         DO I=1,NSOL
            UP(LP+I) = DN(LP+I)
            W(LP+I) = OZALE(LP+I) * (1.90 + COSMAG(I))
         ENDDO

         DO I=1,NSLMP1
            W(I) = 1.9 * OZALE(I)
         ENDDO
         DO L=1,nLMP1
            L0 = (L-1) * NSOL
            DO I=1,NSOL
               W(L0+I) = W(LP+I) - W(L0+I)
            ENDDO
         ENDDO

         DO I=1,NSLMP1
            eo(I) = 103.63 * W(I)
            eo(I) = eo(I) * eo(I) * eo(I)
            VP(I) = 1. + 138.57 * W(I)
            UP(I) = 0.02118 * W(I) / (1. + 0.042 * W(I) +
     *          0.000323 * W(I) * W(I)) + 1.08173 * W(I) /
     *          (vp(i) ** .805) + 0.0658 * W(I) / (1. + eo(I))
         ENDDO

C     COMPUTE OZONE HEATING ON THE WAY UP

         DO I=1,NSLMP1
            W(I) = UP(I) - UP(NSOL+I)
         ENDDO

         DO L=1,nLMP1
            L0 = (L-1) * NSOL
            DO I=1,NSOL
               ACLR(L0+I) = ACLR(L0+I) + W(L0+I) * RLO(I) * SCOSZ(I)
            ENDDO
         ENDDO

         do i=1,nslmp1
            aclr(i) = max(0.0_dbl_kind, aclr(i))
         enddo
      ENDIF

C     CYCLE OVER FIVE BANDS

      DO IK=1,5
         DO L=1,nnp
            L0 = (L-1) * NSOL
            DO I=1,NSOL
               W(L0+I) = SWALE(L0+I) * COSMAG(I)
            ENDDO
         ENDDO

         DO I=1,NSOLNP
            dn(i) = exp(-W(I) * XK(IK))
         ENDDO

C     COMPUTE WATER VAPOR HEATING ON THE WAY DOWN

         DO I=1,NSLMP1
            ACLR(I) = ACLR(I) +
     *         ((DN(I) - DN(NSOL+I)) * FK(IK)) * DEN(I)
         ENDDO

C     GROUND ABSORPTION FOR WAVELENGTHS OVER 0.9 MICRONS

         DO I=1,NSOL
            SL(I) = SL(I) + DN(LP+I) * (1. - RSURFN(I)) *
     *         SCOSZ(I) * FK(IK)
            RNBL(I) = RNBL(I) + DN(LP+I) * SCOSZ(I) * FK(IK)
            UP(LP+I) = DN(LP+I)
            W(LP+I) = SWALE(LP+I) * (SQRT3 + COSMAG(I)) * XK(IK)
         ENDDO

         DO I=1,NSLMP1
            W(I) = SQRT3 * SWALE(I) * XK(IK)
         ENDDO

         DO L=1,nLMP1
            L0 = (L-1) * NSOL
            DO I=1,NSOL
               W(L0+I) = W(L0+I) - W(LP+I)
            ENDDO
         ENDDO

         DO I=1,NSLMP1
            UP(I) = EXP(W(I))
         ENDDO

C     COMPUTE WATER VAPOR HEATING ON THE WAY UP

         DO I=1,NSLMP1
            W(I) = (UP(NSOL+I) - UP(I)) * FK(IK)
         ENDDO

         DO L=1,nLMP1
            L0 = (L-1) * NSOL
            DO I=1,NSOL
               ACLR(L0+I) = ACLR(L0+I) + W(L0+I) * RSURFN(I) * SCOSZ(I)
            ENDDO
         ENDDO
      ENDDO

      DO I=1,NSOL
         DSCLR(I) = SL(I)
         DSCLRtom(I) = SL(I)
      ENDDO

      DO L=1,nLMP1
         L0 = (L-1) * NSOL
         DO I=1,NSOL
            DSCLR(I) = DSCLR(I) + ACLR(L0+I)
         ENDDO
      ENDDO

      DO L=2,nLMP1
         L0 = (L-1) * NSOL
         DO I=1,NSOL
            DSCLRtom(I) = DSCLRtom(I) + ACLR(L0+I)
         ENDDO
      ENDDO

      RETURN
      END

