C--------------------

      SUBROUTINE CRUNCH (INDX1, INDX2, TXUF, TV1,
     *                CSS, CCU, CH, CC, TV2, TUI2, SHI,
     *                RAWI, TUI, SHU, PAI, FLUXU, UBAR, VBAR,
     *                WBAR, UBARM ,OZAI, WBARM,
     *                TAI, FLUXD, VBARM, wdel, fw, OZONE,
     *                len, nlm, nnp )

c	Modifications:
c		- replaced half-precision variables with their actual
c		  values in code.  took out DATA statement.  kwitt 1/29/92
c		- inlined gcmlib calls. kwitt 1/29/92
c               - made implicit none;
c                 implemented multitasked physics
c                          dd 95.10.17

C--------------------

      use kinds

      IMPLICIT none

c     declare argument list arrays

      integer (kind=int_kind) ::
     *  len, nlm, nnp
      REAL (kind=dbl_kind) ::
     * TXUF(len,nnp,nnp),TV1(len,nlm+3),
     * CSS(len,nlm+2),CCU(len,nlm+2),CH(len,nlm+2),
     * CC(len,nlm+3),TV2(len,nlm+3),TUI2(len,nlm+3),
     * RAWI(len,nlm+3),TUI(len,nlm+3),SHU(len,nlm+3),
     * WDEL(len,NLM+1),FW(len,NLM+1),SHI(len,nlm+2)

      REAL (kind=dbl_kind) ::
     * PAI(len,nlm+2),FLUXU(len,nlm+2),UBAR(len,nlm+2),
     * WBAR(len,nlm+2),UBARM(len,nlm+2),OZAI(len,nlm+2),
     * TAI(len,nlm+2),FLUXD(len,nlm+2),VBARM(len,nlm+2),
     * VBAR(len,nlm+2),WBARM(len,nlm+2)
      
      integer (kind=int_kind) ::
     * indx1, indx2
      LOGICAL (kind=log_kind) ::
     * OZONE

c      declare local arrays

      REAL (kind=dbl_kind) ::
     *     ADEL(len,NLM+1),BDEL(len,NLM+1),
     *     X1(len,nlm+3),X2(len,nlm+3),X4(len,nlm+2),
     *     WV(len,NLM+1),YV(len,NLM+1),X3(len,nlm+2),
     *     ZW(len,NLM+1),ZV(len,NLM+1),WW(len,NLM+1),
     *     FU(len,NLM+1),YW(len,NLM+1)
      integer ip, i, l, ix, nlmp1, nnpp1,
     *        n, ip1, i0, i1, i2, imtn

      nlmp1 = nlm+1
      nnpp1 = nnp+1

      DO IP=INDX1,INDX2
         IF (INDX1 .EQ. INDX2) THEN
            IF (INDX2 .EQ. 1) THEN
               do l = 1, nlmp1
                  do i = 1, len
                     x1(i,l) = abs(ubar(i,l+1))
                     x2(i,l) = abs(vbar(i,l+1))
                     x3(i,l) = abs(wbar(i,l+1))
                     adel(i,l) = abs(tai(i,l+1))
                     bdel(i,l) = abs(ch(i,l+1))
                  enddo
               enddo
            ELSE
               DO IX=1,nLM+1
                  do i = 1, len
                     X1(I,IX) = UBAR(I,nNP) - UBAR(I,IX)
                     X2(I,IX) = VBAR(I,nNP) - VBAR(I,IX)
                     X3(I,IX) = WBAR(I,nNP) - WBAR(I,IX)
                     ADEL(I,IX) = TAI(I,nNP) - TAI(I,IX)
                     BDEL(I,IX) = CH(I,nNP) - CH(I,IX)
                  ENDDO

                  IF (OZONE) THEN
                  do i = 1, len
                        WDEL(I,IX) = FLUXU(I,nNP) - FLUXU(I,IX)
                        FW(I,IX) = FLUXD(I,nNP) - FLUXD(I,IX)
                     ENDDO
                  ENDIF
               ENDDO

               do l = 1, nlmp1
                  do i = 1, len
                     x1(i,l)   = abs(x1(i,l))
                     x2(i,l)   = abs(x2(i,l))
                     x3(i,l)   = abs(x3(i,l))
                     adel(i,l) = abs(adel(i,l))
                     bdel(i,l) = abs(bdel(i,l))
                  enddo
               enddo

               IF (OZONE) THEN
                  do l = 1, nlmp1
                     do i = 1, len
                        wdel(i,l) = abs(wdel(i,l))
                        fw(i,l)   = abs(fw(i,l))
                     enddo
                  enddo
               ENDIF
            ENDIF

            IMTN = nlmp1

         ELSE
            IF (INDX2 .EQ. nNP) THEN
               IP1 = IP
               N   = IP - 1
               I0  = 0
               I1  = 1
               I2  = 2
            ELSE
               IP1 = nNP - IP
               N   = IP1
               I0  = IP
               I1  = 0
               I2  = 0
            ENDIF

            DO IX=INDX1,IP1
               do i = 1, len
                  X1(I,IX-I1)   = UBAR(I,IP) - UBARM(I,IX+I0)
                  X2(I,IX-I1)   = VBAR(I,IP) - VBARM(I,IX+I0)
                  X3(I,IX-I1)   = WBAR(I,IP) - WBARM(I,IX+I0)
                  ADEL(I,IX-I1) = TAI(I,IP)  - CSS(I,IX+I0)
                  BDEL(I,IX-I1) = CH(I,IP)   - CCU(I,IX+I0)
               ENDDO

               IF (OZONE) THEN
                  do i = 1, len
                     WDEL(I,IX-I1) = FLUXU(I,IP) - OZAI(I,IX+I0)
                     FW(I,IX-I1)   = FLUXD(I,IP) - PAI(I,IX+I0)
                  ENDDO
               ENDIF
            ENDDO

            imtn = n
            do l = 1, imtn
               do i = 1, len
                  x1(i,l)   = abs(x1(i,l))
                  x2(i,l)   = abs(x2(i,l))
                  x3(i,l)   = abs(x3(i,l))
                  adel(i,l) = abs(adel(i,l))
                  bdel(i,l) = abs(bdel(i,l)) 
               enddo
            enddo

            IF (OZONE) THEN                                                  
               do l = 1, imtn
                  do i = 1, len
      	             wdel(i,l) = abs(wdel(i,l))
   	             fw(i,l)   = abs(fw(i,l))
                  enddo
               enddo
            ENDIF
         ENDIF

         do l = 1, imtn
            do i = 1, len
               FU(i,l) = -9.79 * X1(i,l)
               yw(i,l) = x1(i,l)** .83
               ww(i,l) = x3(i,l)** .6
               ww(i,l) = -27. * yw(i,l) + (-6.7 * x3(i,l) /
     *               (1. + 16. * ww(i,l)))
               yw(i,l) = adel(i,l)** .56
               YW(i,l) = 1.  + 15.1 * YW(i,l)
               YV(i,l) = (-3.1 * ADEL(i,l) / YW(i,l)) + WW(i,l)
               yw(i,l) = bdel(i,l)** .57
               YW(i,l) = 1. + .9 * YW(i,l)
               WV(i,l) = (-.04 * BDEL(i,l) / YW(i,l)) + WW(i,l)
            ENDDO
         ENDDO

         IF (OZONE) THEN
            do l = 1, imtn
               do i = 1, len
                  FW(i,l) = FW(i,l) / (WDEL(i,l) * 1013.25)
                  ZV(i,l) = 1381.12 * WDEL(i,l) / (.8796 * FW(i,l))
                  ADEL(i,l) = -4.398 * FW(i,l) *
     *               ((sqrt ((1. + zv(i,l))))- 1.)
                  zv(i,l) = exp(adel(i,l))
                  FW(i,l) = 1. - 6.7675 e-01 * (1. - ZV(i,l))
               ENDDO
            ENDDO

         ELSE
            do l = 1, imtn
               do i = 1, len
                  FW(i,l) = 1.
               ENDDO
            ENDDO
         ENDIF

         do l = 1, imtn
            do i = 1, len
               adel(i,l) = exp(yv(i,l))
               bdel(i,l) = exp(wv(i,l))
               wdel(i,l) = exp(fu(i,l))
               yw (i,l) = sqrt(x2(i,l))
               zw (i,l) = sqrt(x3(i,l))
               WW(i,l) = ((1. + 32.2095 * X1(i,l)) /
     *            (1. + 52.85 * X1(i,l)) +
     *            (0.534874 + 199.0 * X1(i,l) - 1990.63 * X1(i,l) *
     *            X1(i,l)) * ZW(i,l) / (1. + 333.244 * X1(i,l))) /
     *            ((1. + 74.144 * X1(i,l))/(0.43368 + 24.7442*X1(i,l))*
     *            ZW(i,l) + 1.)
               WV(i,l) = 1. / ((1. + 9.22411 * YW(i,l) + 33.1236 *
     *            X2(i,l) + 176.396 * X2(i,l) * X2(i,l)))
               ww(i,l) = max(0.0_dbl_kind, ww(i,l))
               wv(i,l) = max(0.0_dbl_kind, wv(i,l))
               x1(i,l) = min(.060_dbl_kind, x1(i,l))
               x2(i,l) = min(2.0_dbl_kind, x2(i,l))
               x3(i,l) = min(8.0_dbl_kind, x3(i,l))
               yw(i,l)= sqrt (x2(i,l))
               zw(i,l)= sqrt (x3(i,l))
               FU(i,l) = X1(i,l) * X1(i,l)
c The following statement is rewritten because the sgi can't do the 
c   arithmetic right
c               YV(i,l) = (0.0851069 * YW(i,l) - 0.187096 * X2(i,l) *
c     *            YW(i,l) + 0.323105 * X2(i,l)) * 0.1
               YV(i,l) = 0.00851069 * YW(i,l)
               YV(i,l) = yv(i,l) - 0.0187096 * X2(i,l) * YW(i,l)
               YV(i,l) = yv(i,l) + 0.0323105 * X2(i,l)
               ZV(i,l) = (0.239186 * X2(i,l) - 0.0922289 * X2(i,l) *
     *            YW(i,l) - 0.0167413 * X2(i,l) * X2(i,l)) * .001
c The following statements are rewritten because the sgi can't do the 
c   arithmetic right
c              YW(i,l) = (5.6383 e -04 + 1.05173 * X1(i,l) - 39.0722 *
c    *            FU(i,l)) / (1. + 202.357 * X1(i,l)) +
c    *            (0.0779555 + 4.40720 * X1(i,l) + 3.15851 * FU(i,l)) *
c    *            ZW(i,l) / (1. + 40.2298 * X1(i,l)) +
c    *            (-0.0381305 - 3.63684 * X1(i,l) + 7.98951 * FU(i,l)) *
c    *            X3(i,l) / (1. + 62.5692 * X1(i,l)) +
c    *            (6.21039 e -03 + 0.710061 * X1(i,l) - 2.85241 *
c    *            FU(i,l)) * X3(i,l) / (1. + 70.2912 * X1(i,l))*ZW(i,l)
c              YW(i,l) = 1.0 e-1 * YW(i,l)
               YW(i,l) = (5.6383 e -05 + .105173 * X1(i,l) - 3.90722 *
     *            FU(i,l)) / (1. + 202.357 * X1(i,l)) +
     *            (0.00779555 + .440720 * X1(i,l) + .315851 * FU(i,l)) *
     *            ZW(i,l) / (1. + 40.2298 * X1(i,l)) +
     *            (-0.00381305 - .363684 * X1(i,l) + .798951 * FU(i,l)) *
     *            X3(i,l) / (1. + 62.5692 * X1(i,l)) +
     *            (6.21039 e -04 + 0.0710061 * X1(i,l) - .285241 *
     *            FU(i,l)) * X3(i,l) / (1. + 70.2912 * X1(i,l))*ZW(i,l)
               ZW(i,l) = (-2.99542 e -04 + 0.238219 * X1(i,l)+0.519264 *
     *            FU(i,l)) / (1. + 10.7775 * X1(i,l)) +
     *            (-2.91325 e -02 - 2.30007 * X1(i,l) + 10.946*FU(i,l))*
     *            ZW(i,l) / (1. + 63.519 * X1(i,l)) +
     *            (1.43812 e -02  + 1.80265 * X1(i,l) - 10.1311 *
     *            FU(i,l)) * X3(i,l) / (1. + 98.4758 * X1(i,l)) +
     *            (-2.39016 e -03 - 3.71427 e -01 * X1(i,l) + 2.35443 *
     *            FU(i,l)) * X3(i,l) / (1. + 120.228 * X1(i,l))*ZW(i,l)
               ZW(i,l) = 1.0 e -03 * ZW(i,l)
            ENDDO
         ENDDO

         IF (INDX1 .EQ. INDX2) THEN
            do l = 1, nlmp1
               do i = 1, len
                  ADEL(i,l) = 3.84615384 e -01 * ADEL(i,l) +
     *                  6.15384615 e -01 * BDEL(i,l)
                  FW(i,l) = FW(i,l) * WDEL(i,l)
               ENDDO
            ENDDO

            IF (INDX2 .EQ. 1) THEN
               DO IX=2,nNP
                  do i = 1, len
                     X1(I,IX) = WV(I,IX-1) * TV1(I,1)
                     X2(I,IX) = YV(I,IX-1) * TUI(I,1) + 1. +
     *                  ZV(I,IX-1) * TUI2(I,1)
                     X3(I,IX) = WW(I,IX-1) * TV2(I,1)
                     X4(I,IX) = YW(I,IX-1) * TUI(I,1) + 1. +
     *                  ZW(I,IX-1) * TUI2(I,1)
                     FW(I,IX-1) = ADEL(I,IX-1) * CC(I,1) +
     *                  FW(I,IX-1) * RAWI(I,1)
                  ENDDO
               ENDDO

               do l = 1, nlmp1
                  do i = 1, len
                     SHI(I,l+1) = X1(I,l+1) * X2(I,l+1) + X3(I,l+1) *
     *                      X4(I,l+1) + FW(I,l)
                  ENDDO
               ENDDO
            ELSE
               DO IX=1,nLMP1
                  do i = 1, len
                     X1(I,IX) = WV(I,IX) * TV1(I,nNPP1) * (YV(I,IX) *
     *                  TUI(I,nNPP1) + 1. + ZV(I,IX) * TUI2(I,nNPP1))
                     X2(I,IX) = WW(I,IX) * TV2(I,nNPP1) * (YW(I,IX) *
     *                  TUI(I,nNPP1) + 1. + ZW(I,IX) * TUI2(I,nNPP1))
                     X3(I,IX) = WV(I,IX) * TV1(I,nNP) * (YV(I,IX) *
     *                  TUI(I,nNP) + 1. + ZV(I,IX) * TUI2(I,nNP))
                     X4(I,IX) = WW(I,IX) * TV2(I,nNP) * (YW(I,IX) *
     *                  TUI(I,nNP) + 1. + ZW(I,IX) * TUI2(I,nNP))

                     SHU(I,IX) = (CC(I,nNPP1) - CC(I,nNP)) * ADEL(I,IX)+
     *                  (RAWI(I,nNPP1) - RAWI(I,nNP)) * FW(I,IX)
                  ENDDO
               ENDDO

               do l = 1, nlmp1
                  do i = 1, len
                     SHU(i,l) = X1(i,l) + X2(i,l) - X3(i,l) - X4(i,l)
     *                     + SHU(i,l)
                  ENDDO
               ENDDO
            ENDIF
         ELSE
            do l = 1, imtn
               do i = 1, len
                  X1(I,l) = WV(I,l) * TV1(I,I0+l) * (YV(I,l) *
     *                  TUI(I,I0+l) + 1. + ZV(I,l) * TUI2(I,I0+l))
                  X2(I,l) = WW(I,l) * TV2(I,I0+l) * (YW(I,l) *
     *                  TUI(I,I0+l) + 1. + ZW(I,l) * TUI2(I,I0+l))
                  X3(I,l) = WV(I,l) * TV1(I,I0+I2+l-1) * (YV(I,l) *
     *                  TUI(I,I0+I2+l-1) + 1. + ZV(I,l)*TUI2(I,I0+I2+l-1))
                  X4(I,l) = WW(I,l) * TV2(I,I0+I2+l-1) * (YW(I,l) *
     *                  TUI(I,I0+I2+l-1) + 1. + ZW(I,l)*TUI2(I,I0+I2+l-1))

                  TXUF(I,I0+l,IP) = X1(I,l) + X2(I,l) - X3(I,l)-X4(I,l)+
     *                  (CC(I,I0+l) - CC(I,I0+I2+l-1)) *
     *                  (3.84615384 e -01 * ADEL(I,l) +
     *                  6.15384615 e -01 * BDEL(I,l)) +
     *                  (RAWI(I,I0+l) - RAWI(I,I0+I2+l-1)) * FW(I,l) *
     *                  WDEL(I,l)
               ENDDO
            ENDDO
         ENDIF
      ENDDO

      RETURN
      END

