      module cpl_cubic_module
c.............................................................................

      use kinds
        
      IMPLICIT none
      private
      
      public :: cpl_cubic
      
      contains

      SUBROUTINE cpl_CUBIC(ZEROC, ONEC, TWOC, FSOLN, CSSOLN, CTSOLN,
     +                 sumcoeff, threereal)

c argument list
      REAL (kind=dbl_kind), intent(in) ::
     *      zeroc,onec,twoc
      logical (kind=int_kind), intent(out) ::
     *      threereal
      COMPLEX (kind=dbl_kind), intent(out) ::
     *      CSSOLN,CTSOLN
      REAL (kind=dbl_kind), intent(out) ::
     *      fsoln,sumcoeff

c local variables
      COMPLEX (kind=dbl_kind) ::
     *      CSSUM1,CSSUM2,CSOLN1,CSOLN2,CSUMCOEFF
      REAL (kind=dbl_kind) ::
     *      qcubed
      REAL (kind=dbl_kind) ::
     *      qcoeff,rcoeff
      REAL (kind=dbl_kind) ::
     *      rssoln, rtsoln, rssum1, rssum2, rsoln1, rsoln2

      threereal = .true.

      QCOEFF = ONEC/3.-((TWOC**2)/9.)
      RCOEFF = (((ONEC*TWOC)-(3.*ZEROC))/6.)-((TWOC**3.0)/27.)
      if (qcoeff .lt. 0.) then
         qcubed = (abs(qcoeff))**3.0
         qcubed = -qcubed
      else
         qcubed = qcoeff**3.0
      endif

c...DETERMINE TYPE OF ROOTS BASED ON Q & R COEFF
      SUMCOEFF = qcubed+(RCOEFF**2.)

      IF (SUMCOEFF.LT.0.) THEN                      ! 3 REAL ROOTS
         CSUMCOEFF = SUMCOEFF
         CSSUM1 = RCOEFF+(CSUMCOEFF)**0.5 ! COMPLEX
         CSSUM2 = RCOEFF-(CSUMCOEFF)**0.5 ! COMPLEX
         CSOLN1 = CSSUM1**(1./3.) ! COMPLEX
         CSOLN2 = CSSUM2**(1./3.) ! COMPLEX
         FSOLN = CSOLN1+CSOLN2-(TWOC/3.) ! ALWAYS REAL
         RSSOLN = -0.5*(CSOLN1+CSOLN2)+(0.5*SQRT(3.)*(0.,1.)* !REAL
     *            (CSOLN1-CSOLN2))-(TWOC/3.)
         RTSOLN = -0.5*(CSOLN1+CSOLN2)-(0.5*SQRT(3.)*(0.,1.)* !REAL
     *            (CSOLN1-CSOLN2))-(TWOC/3.)
         CSSOLN = RSSOLN
         CTSOLN = RTSOLN
      ELSE                                          ! 1 REAL ROOT
         threereal = .false.
         RSSUM1 = RCOEFF+(SUMCOEFF)**0.5 ! REAL MAY BE <0.
         RSSUM2 = RCOEFF-(SUMCOEFF)**0.5 ! REAL MAY BE <0.
         RSOLN1 = (ABS(RSSUM1))**(1./3.) ! REAL >0.
         RSOLN2 = (ABS(RSSUM2))**(1./3.) ! REAL >0.
                        
c...IF RSSUM1 OR RSSUM2 <0 THEN CHANGE SIGN OF RSOLN1 OR RSOLN2
         IF (RSSUM1.LT.0.) RSOLN1 = -RSOLN1 ! REAL <0.
         IF (RSSUM2.LT.0.) RSOLN2 = -RSOLN2 ! REAL <0.
         FSOLN = (RSOLN1+RSOLN2)-(TWOC/3.) ! ALWAYS REAL
         CSSOLN = -0.5*(RSOLN1+RSOLN2)+(0.5*SQRT(3.)*(0.,1.)* !COMPLEX
     *            (RSOLN1-RSOLN2))-(TWOC/3.)
         CTSOLN = -0.5*(RSOLN1+RSOLN2)-(0.5*SQRT(3.)*(0.,1.)* !COMPLEX
     *            (RSOLN1-RSOLN2))-(TWOC/3.)
      ENDIF ! SUMMCOEFF<0.

      END   subroutine cpl_cubic      ! SUBROUTINE CUBIC

      end module cpl_cubic_module
