C--------------------

      SUBROUTINE LWFLUX (co2fac, TXUF, TV1, DP,
     *                   CSS, CCU, CH, CC, TV2, TUI2, SHI,
     *                   RAWI, TUI, SHU,
     *                   SHH, SUMSAV, DTB, DTBINV, PR,
     *                   PAI, FLUXU, UBAR, VBAR,
     *                   WBAR, UBARM, OZAI, WBARM,
     *                   TAI, FLUXD, VBARM, OZONE, len, nlm, nnp )

c	Modifications:
c		- inlined gcmlib calls.  kwitt 1/28/92

C--------------------

      use kinds

      IMPLICIT none

c     declare argument list arrays
      integer (kind=int_kind) ::
     *  nlm, len, nnp
      REAL (kind=dbl_kind) ::
     * TXUF(len,nnp,nnp),TV1(len,nlm+3),DP(len,nlm+2),
     * CSS(len,nlm+2),CCU(len,nlm+2),CH(len,nlm+2),
     * CC(len,nlm+3),TV2(len,nlm+3),TUI2(len,nlm+3),
     * RAWI(len,nlm+3),TUI(len,nlm+3),SHU(len,nlm+1),
     * SHH(len,nlm+2),SUMSAV(len),DTB,DTBINV,PR(2)
      REAL (kind=dbl_kind) ::
     * PAI(len,nlm+2),FLUXU(len,nlm+2),UBAR(len,nlm+2),
     * WBAR(len,nlm+2),UBARM(len,nlm+2),OZAI(len,nlm+2),
     * TAI(len,nlm+2),FLUXD(len,nlm+2),VBARM(len,nlm+2),
     * SHI(len,nlm+2),VBAR(len,nlm+2),WBARM(len,nlm+2),
     * co2fac

      LOGICAL (kind=log_kind) ::
     *  OZONE

c     declare local arrays
      REAL (kind=dbl_kind) ::
     *     X1(len,nlm+3),X2(len,nlm+3),FW(len,nlm+1),
     *     WDEL(len,nlm+1)
      integer (kind=int_kind) ::
     *     IT(len,nlm+3)

      REAL (kind=dbl_kind) ::
     * B2501(32),B2502(32),BLKWIN(32),BLKCO2(32)
     *,    temp1, pp
      integer (kind=int_kind) ::
     * nnpp1, nlmp1, ntm1, i, ip, ix, indx1, indx2, j, l

C     CONSTANTS

      DATA TEMP1/1.65 e 02/, PP/1./

      DATA B2501 / 16.280, 17.471, 18.701, 19.974, 21.292,
     *             22.661, 24.086, 25.575, 27.135, 28.775,
     *             30.506, 32.339, 34.286, 36.361, 38.578,
     *             40.954, 43.505, 46.248, 49.203, 52.388,
     *             55.824, 59.532, 63.533, 67.849, 72.502,
     *             77.516, 82.913, 88.717, 94.952, 101.64,
     *            108.806,116.472/

      DATA B2502/ 16.379, 18.744, 21.345, 24.195, 27.311,
     *            30.708, 34.405, 38.417, 42.763, 47.461,
     *            52.529, 57.985, 63.850, 70.141, 76.880,
     *            84.088, 91.784, 99.99, 108.726, 118.016,
     *           127.881, 138.344, 149.429, 161.160, 173.561,
     *           186.659, 200.478, 215.046, 230.390, 246.539,
     *           263.523, 281.368/

      DATA BLKWIN/ 0.593, 0.774, 0.993, 1.258, 1.573,
     *             1.944, 2.377, 2.877, 3.450, 4.102,
     *             4.838, 5.664, 6.585, 7.606, 8.733,
     *             9.969, 11.320, 12.788, 14.380, 16.097,
     *            17.944, 19.923, 22.038, 24.292, 26.685,
     *            29.221, 31.902, 34.729, 37.703, 40.825,
     *            44.097, 47.520/

C        NEW PLANCK FUNCTION (WIDE BAND)

      DATA BLKCO2/  8.789, 10.385, 12.159, 14.117, 16.264,
     *             18.606, 21.145, 23.884, 26.826, 29.973,
     *             33.325, 36.883, 40.647, 44.617, 48.792,
     *             53.170, 57.750, 62.530, 67.509, 72.683,
     *             78.050, 83.609, 89.354, 95.285, 101.397,
     *            107.688, 114.155, 120.794, 127.601, 134.574,
     *            141.710, 149.004/

      nlmp1 = nlm+1
      nnpp1 = nnp + 1
      NTM1 = 31

      DO I=1,len
         SHI(I,1) = 0.
      ENDDO

      DO l=1,nnp
         DO j=1,nnp
            DO I=1,len
               TXUF(I,j,l) = 0.
            ENDDO
         ENDDO
      ENDDO

      DO l=1,nnpp1
         DO I=1,len
            it(i,l) = (TUI(I,l) - TEMP1) * DTBINV + 1.5
            it(i,l) = min0(ntm1, it(i,l))
            it(i,l) = max0(1, it(i,l))
            RAWI(I,l) = (TUI(I,l) - (TEMP1 + (it(i,l) - 1.) * DTB)) *
     *         DTBINV
            x1(i,l) = b2501(it(i,l))
            x2(i,l) = b2501(it(i,l)+1)
            TV1(I,l) = X1(I,l) + (X2(I,l) - X1(I,l)) * RAWI(I,l)
            x1(i,l) = b2502(it(i,l))
            x2(i,l) = b2502(it(i,l)+1)
            TV2(I,l) = X1(I,l) + (X2(I,l) - X1(I,l)) * RAWI(I,l)
         ENDDO
      ENDDO

      DO l=1,nnp
         DO I=1,len
            SHH(I,l) = TV1(I,l) + TV2(I,l)
         ENDDO
      ENDDO

      DO I=1,len
         SUMSAV(I) = TV1(I,nNPP1) + TV2(I,nNPP1)
      ENDDO

      DO l=1,nnpp1
         DO I=1,len
            TUI(I,l)  = TUI(I,l) - 2.5 e 02
            TUI2(I,l) = TUI(I,l) * TUI(I,l)

C     CARBON DIOXIDE AND OZONE FLUXES ARE CALCULATED HERE.

            x2(i,l) = blkco2(it(i,l))
            x1(i,l) = blkco2(it(i,l)+1)
            CC(I,l) = X2(I,l) + (X1(I,l) - X2(I,l)) * RAWI(I,l)
            x2(i,l) = blkwin(it(i,l))
            x1(i,l) = blkwin(it(i,l)+1)
            RAWI(I,l) = X2(I,l) + (X1(I,l) - X2(I,l)) * RAWI(I,l)
         ENDDO
      ENDDO

C     COMPUTE TRANSMITTANCES IN THE 15 MICRON AND 9.6 MICRON BANDS.

      DO l=1,nlmp1
         DO I=1,len
            ch(i,l+1) = exp((2.5 e -02 * (TAI(I,l+1) - 240.)))
            tai(i,l+1) = exp((8.9 e -03 * (TAI(I,l+1) - 240.)))
         ENDDO
      ENDDO

      DO I=1,len
         TAI(I,1) = 0.
         CH(I,1)  = 0.
      ENDDO

      DO l=1,nlmp1
         DO I=1,len
            X1(I,l) = PAI(I,l)

! tdrmod - ibm does not like the max function
   	    if(pp.gt.x1(i,l)) x1(i,l) = pp
!           x1(i,l) = max(pp, x1(i,l))
! endtdrmod
            FW(I,l) = X1(I,l) * PR(1)

            x2(i,l) = fw(i,l)** .85
            TAI(I,l+1) = X2(I,l) * TAI(I,l+1)
            x1(i,l) = sqrt((X1(I,l) * PR(2)))

C     HP25 = 0.26 FOR CO2 = 330 PPMV (linear for other concentrations)

            TAI(I,l+1) = DP(I,l+1) * TAI(I,l+1) * 2.6 e -01 * co2fac
            CH(I,l+1) = DP(I,l+1) * (x1(i,l) * CH(I,l+1)) * 2.6 e -01 * co2fac
         ENDDO
      ENDDO

      DO IP=2,nNP
         DO I=1,len
            TAI(I,IP) = TAI(I,IP-1) + TAI(I,IP)
            CH(I,IP) = CH(I,IP-1) + CH(I,IP)
         ENDDO
      ENDDO

      DO l=1,nlmp1
         DO I=1,len
            CSS(I,l+1) = (TAI(I,l+1) + TAI(I,l)) * .5
            CCU(I,l+1) = (CH(I,l+1) + CH(I,l)) * .5
         ENDDO
      ENDDO

      IF (OZONE) THEN
         DO I=1,len
            FLUXD(I,1) = 0.
         ENDDO

         DO l=1,nnp
            DO I=1,len
               FLUXU(I,l) = 0.
            ENDDO
         ENDDO

         DO l=1,nlmp1
            DO I=1,len
               FLUXD(I,l+1) = PAI(I,l) * OZAI(I,l+1)
            ENDDO
         ENDDO

         DO IX=2,nNP
            DO I=1,len
               FLUXD(I,IX) = FLUXD(I,IX-1) + FLUXD(I,IX)
               FLUXU(I,IX) = FLUXU(I,IX-1) + OZAI(I,IX)
            ENDDO
         ENDDO

         DO l=1,nlmp1
            DO I=1,len
               PAI(I,l+1) = (FLUXD(I,l) + FLUXD(I,l+1)) * .5
               OZAI(I,l+1) = (FLUXU(I,l) + FLUXU(I,l+1)) * .5
               wdel(i,l) = abs(fluxu(i,l+1))
               fw(i,l) = abs(fluxd(i,l+1))
            enddo
         enddo
      ENDIF

      INDX1 = 1
      INDX2 = 1

      CALL CRUNCH  (INDX1, INDX2, TXUF, TV1,
     *                CSS, CCU, CH, CC, TV2, TUI2, SHI,
     *                RAWI, TUI, SHU, PAI, FLUXU, UBAR, VBAR,
     *                WBAR, UBARM ,OZAI, WBARM,
     *                TAI, FLUXD, VBARM, wdel, fw, OZONE,
     *                len, nlm, nnp )

      INDX1 = 2
      INDX2 = 2

      CALL CRUNCH  (INDX1, INDX2, TXUF, TV1,
     *                CSS, CCU, CH, CC, TV2, TUI2, SHI,
     *                RAWI, TUI, SHU, PAI, FLUXU, UBAR, VBAR,
     *                WBAR, UBARM ,OZAI, WBARM,
     *                TAI, FLUXD, VBARM, wdel, fw, OZONE,
     *                len, nlm, nnp )

C     DOWNWARD FLUX TXUF FOR WATER VAPOR

      INDX1 = 2
      INDX2 = nNP

      CALL CRUNCH  (INDX1, INDX2, TXUF, TV1,
     *                CSS, CCU, CH, CC, TV2, TUI2, SHI,
     *                RAWI, TUI, SHU, PAI, FLUXU, UBAR, VBAR,
     *                WBAR, UBARM ,OZAI, WBARM,
     *                TAI, FLUXD, VBARM, wdel, fw, OZONE,
     *                len, nlm, nnp )

C     UPWARD FLUX TXUF FOR WATER VAPOR

      INDX1 = 1
      INDX2 = nLMP1

      CALL CRUNCH  (INDX1, INDX2, TXUF, TV1,
     *                CSS, CCU, CH, CC, TV2, TUI2, SHI,
     *                RAWI, TUI, SHU, PAI, FLUXU, UBAR, VBAR,
     *                WBAR, UBARM ,OZAI, WBARM,
     *                TAI, FLUXD, VBARM, wdel, fw, OZONE,
     *                len, nlm, nnp )

      DO l=1,nnp
         DO I=1,len
            SHH(I,l) = SHH(I,l) + RAWI(I,l) + CC(I,l)
         ENDDO
      ENDDO

      DO I=1,len
         SUMSAV(I) = SUMSAV(I) + RAWI(I,nNPP1) + CC(I,nNPP1)
      ENDDO

      RETURN
      END

