C--------------------

      SUBROUTINE SETSW (PU,TA,WA,OA
     *,                 Dp,DPC,SCOSZ,CMU,COSMAG
     *,                 CSS,CCU,SL,ACLR,DSCLR,SC,ACLD
     *,                 RVBL,RVDL,RNBL,RNDL,RVBC
     *,                 RVDC,RNBC,RNDC,AGV,RSURFV
     *,                 AGN,RSURFN,DSCLD,DOOZ,BITD
     *,                 NSOL,NSOLP1,NSLMP1,NSOLNP,NCLD,fracanv
     *,                 eoanv,eonoanv,om,gwi,dsclrtom,dscldtom
     *,                 len, imnnp, imlmp1, nlmp1 )

c	Modifications:
c		- bitwrk.com include removed.  sequential array listim
c		  done in routine with i8vint.  changed dimension of listim
c		  in this routine to imnnp.  kwitt 7/5/91
c		- inlined gcmlib.F subroutines.  kwitt 1/22/92
c               - replace common /work/ with argument list.
c                    dd 11/09/92
c		- cloud optical depth, single scatter albedo, and asymmetry
c		  constant now passed in as arguments instead of being 
c		  prescribed from within the radiation code
c		     dd 02/24/92
c               - added top of model fluxes. dd 08/21/95

C--------------------

      use kinds

      IMPLICIT none

c     argument list declared
      integer (kind=int_kind) ::
     *        len, imlmp1, imnnp, nlmp1
      REAL (kind=dbl_kind) ::
     *        PU(IMNNP),TA(IMLMP1),WA(IMLMP1),OA(IMLMP1)
     *,       DP(IMLMP1),DPC(IMLMP1),ACLD(IMLMP1)
     *,       SCOSZ(len),CMU(len),COSMAG(len)
     *,       CSS(IMLMP1),CCU(IMLMP1),RVBC(len)
     *,       SL(len),ACLR(IMLMP1),DSCLR(len),SC(len)
     *,       RVBL(len),RVDL(len),RNBL(len),RNDL(len)
     *,       RVDC(len),RNBC(len),RNDC(len),AGV(len)
     *,       AGN(len),RSURFN(len),DSCLD(len)
     *,       RSURFV(len),eoanv(imlmp1),gwi(imlmp1),om(imlmp1)
     *,       eonoanv(imlmp1),dscldtom(len),dsclrtom(len)
     *,       dscldtemtom(len)
      integer (kind=int_kind) ::
     *        NSOL,NSOLP1,NSLMP1,NSOLNP,NCLD

      LOGICAL (kind=log_kind) ::
     *        DOOZ,BITD(IMNNP),fracanv

c     local arrays declared

      logical (kind=log_kind) ::
     *     BITC(IMNNP),bita(imnnp)
      REAL (kind=dbl_kind) ::
     *     ARG1(len),AA1(len),E1(len),UPIM(len)
     *,    RC1(len),TLIM(len),G(len),TAUI(len)
     *,    AGVCD(len),RSVCD(len),RSNCD(len)
     *,    CSMCLD(len),OZCD(IMNNP),CMUC(len),SCOSC(len)
     *,    TAUC(IMLMP1),TAUT(len),RCO(len),RCG(len)
     *,    OZALE(IMNNP),RLO(len),RLG(len),C1(len)
     *,    SWIL(IMLMP1),SWALE(IMNNP),SWILC(IMLMP1),AGNCD(len)
     *,    RC2(len),TR1(len),TR2(len),TR3(len)
     *,    DNIM(len),B1(len),omcld(imlmp1),ggwi(imlmp1)
     *,    gwt(len)
c     temporary arrays for fractional anvils
      REAL (kind=dbl_kind) ::
     *     ccutem(imlmp1),csstem(imlmp1),sctem(len)
     *,    anvfrac(len),acldtem(imlmp1),dscldtem(len)
     *,    rvbctem(len),rvdctem(len),rnbctem(len)
     *,    rndctem(len),coanfrac(len), sqrt3, rcn1, rcn2, athrd, tthrd
      INTEGER (kind=int_kind) ::
     *        ICL(len), ICC(len), LITD(IMNNP)
     *,       icctem(len), i, l, nnp, l0, l1, k, il, nlm
     *,       ncldtem, ncldp1, nclmp1, ncldnp, j

c     create sequential array of indices

      sqrt3 = sqrt(3.)
      RCN1   = 1. / 6.55
      RCN2   = 1. / 4.47238
      ATHRD  = 1. / 3.
      TTHRD  = 2. / 3.
      nlm = nlmp1-1
      nnp = nlm+2

C     ZERO OUT OZONE BELOW 500 MB

      IF (DOOZ) THEN
         do i=1,nslmp1
            bitc(i) = pu(nsolp1+i-1) .gt. 500.
            if (bitc(i)) oa(i) = 0.
            OA(I) = 476. * OA(I) * DP(I)
         enddo

C     COMPUTE OZONE AND WATER VAPOR AMOUNTS

         DO I=1,NSOL
            OZALE(I) = 0.
         ENDDO

         DO L=2,nNP
            L0 = (L-2) * NSOL
            L1 = (L-1) * NSOL
            DO I=1,NSOL
               OZALE(L1+I) = OZALE(L0+I) + OA(L0+I)
            ENDDO
         ENDDO
      ENDIF

      DO I=1,NSOL
         SWALE(I) = 0.
      ENDDO

      DO I=1,NSOLNP
         PU(I) = PU(I) * PU(I)
      ENDDO

      DO I=1,NSLMP1
         SWIL(I) = (PU(NSOL+I) - PU(I)) * WA(I) /
     *      (120.1612 * sqrt(ta(i)))
      ENDDO

      DO L=2,nNP
         L0 = (L-2) * NSOL
         L1 = (L-1) * NSOL
         DO I=1,NSOL
            SWALE(L1+I) = SWALE(L0+I) + SWIL(L0+I)
         ENDDO
      ENDDO

C     COMPUTE CLEAR SKY REFLECTIVITIES                                  
C     CLEAR SKY OZONE REFLECTION, TAURAY=0.85                           

      DO I=1,NSOL
         upim(i) = 1. - (((2. + (3. * cmu(i))) +
     *      (2. - (3. * cmu(i))) *exp(-.85 * cosmag(i))) * RCN1)

         DNIM(I) = (((2. + (3. * cmu(i))) + (2. - (3. * cmu(i))) *
     *      exp(-.85 * cosmag(i))) * RCN1) - exp(-.85 * cosmag(i)) 

         RLO(I)  = TTHRD * RSURFV(I) + ATHRD *
     *      (UPIM(I) + (exp(-.85 * cosmag(i)) * RSURFV(I) +
     *      DNIM(I) * AGV(I)) * 0.576004/(1. - 0.423996 *AGV(I)))

C     CLEAR SKY GROUND REFLECTION, TAURAY=0.15746                       

         TR1(I)  = exp(-.15746 * cosmag(i))

         upim(i) = 1. - (((2. + (3. * cmu(i))) +
     *      (2. - (3. * cmu(i))) *exp(-.15746 * cosmag(i))) * RCN2)

         DNIM(i) = (((2. + (3. * cmu(i))) + (2. - (3. * cmu(i))) *
     *      exp(-.15746 * cosmag(i)))*RCN2) - exp(-.15746 * cosmag(i))

         RLG(I)  = UPIM(I) + (exp(-.15746 * cosmag(i)) * RSURFV(I) +
     *      DNIM(I) * AGV(I)) * 0.88 / (1. - 0.12 * AGV(I))
      ENDDO

      CALL CLEAR( dooz, SQRT3,SCOSZ,COSMAG
     *,       SL,ACLR,DSCLR,dsclrtom,OZALE,RLO,RLG,SWALE
     *,       RVBL,RVDL,RNBL,RNDL,RSURFN,AGV,RSURFV,TR1
     *,       NSOL,NSLMP1,NSOLNP, len, imnnp, imlmp1, nlmp1)

C     FIND CLOUD TOP - SOLID ANVILS CASE

      do i=1,nslmp1
         ccutem(i) = 0.0
         if(ccu(i).gt.1.e-7)ccutem(i) = 1.0
         csstem(i) = max(ccutem(i), css(i))
      enddo

      DO I=1,NSOL
         ICC(I) = nNP
      ENDDO

      DO K=1,nLMP1
         L=nNP-K
         L0 = (L-1) * NSOL + 1
         do i=1,nsol
            bitc(i) = csstem(l0+i-1) .gt. 0.001
            if (bitc(i)) icc(i) = l
         enddo
      ENDDO

      ncld = 0
      do i=1,nsol
         bitd(i) = icc(i) .ne. nnp
         if(bitd(i)) ncld = ncld + 1
      enddo


      IF (NCLD .EQ. 0) THEN
         DO I=1,NSLMP1
            ACLD(I) = ACLR(I)
         ENDDO

         DO I=1,NSOL
            SC(I)    = SL(I)
            DSCLD(I) = DSCLR(I)
            DSCLDtom(I) = DSCLRtom(I)
            RNDC(I)  = RNDL(I)
            RVDC(I)  = RVDL(I)
            RNBC(I)  = RNBL(I)
            RVBC(I)  = RVBL(I)
         ENDDO

         RETURN
      ENDIF


C     FIND CLOUD TOP - NO ANVILS CASE
      if(fracanv) then

      do i=1,nslmp1
         ccutem(i) = 0.0
         csstem(i) = css(i)
      enddo

      DO I=1,NSOL
         icctem(I) = nNP
      ENDDO

      DO K=1,nLMP1
         L=nNP-K
         L0 = (L-1) * NSOL + 1
         do i=1,nsol
            bitc(i) = csstem(l0+i-1) .gt. 0.
            if (bitc(i)) icctem(i) = l
         enddo
      ENDDO

      ncldtem = 0
      do i=1,nsol
         bita(i) = icctem(i) .ne. nnp
         if(bita(i)) ncldtem = ncldtem + 1
      enddo

         DO I=1,NSLMP1
            ACLDtem(I) = ACLr(I)
         ENDDO

         DO I=1,NSOL
            SCtem(I)    = Sl(I)
            DSCLDtem(I) = DSCLr(I)
            DSCLDtemtom(I) = DSCLrtom(I)
            RNDCtem(I)  = RNDl(I)
            RVDCtem(I)  = RVDl(I)
            RNBCtem(I)  = RNBl(I)
            RVBCtem(I)  = RVBl(I)
         ENDDO

      IF (NCLDtem .ne. 0) THEN

      NCLDP1 = NCLDtem + 1
      NCLMP1 = NCLDtem * nLMP1
      NCLDNP = NCLDtem * nNP

      DO L=1,nLMP1
         L1 = L * NSOL + 1
         do i=1,nsol
            bita(l1+i-1) = icctem(i) .ne. nnp
         enddo
      ENDDO

C     COMPRESS OUT CLOUDY GRID POINT VALUES FOR OZONE AMT., WATER AMT.,
C     SCOSZ, ETC.

      j=1
      do i=1,nsolnp
         if (bita(i)) then
            litd(j) = i
            j = j+1
         endif
      enddo

      do i = 1,ncldtem
         icl(i) = icctem(litd(i))
         cmuc(i) = cmu(litd(i))
         agvcd(i) = agv(litd(i))
         agncd(i) = agn(litd(i))
         rsvcd(i) = rsurfv(litd(i))
         rsncd(i) = rsurfn(litd(i))
         scosc(i) = scosz(litd(i))
         csmcld(i) = cosmag(litd(i))
      enddo
      do i = 1,nclmp1
         swilc(i) = swil(litd(i))
         tauc(i) = eonoanv(litd(i))
         ggwi(i) = gwi(litd(i))
         omcld(i) = om(litd(i))
      enddo

      IF (DOOZ) THEN
         do i = 1,ncldnp
            ozcd(i) = ozale(litd(i))
         enddo

C        MAKE OZONE AMOUNT CONSTANT BELOW CLOUD TOP

         DO L=1,nLMP1
            L0 = (L-1) * ncldtem + 1
            L1 = L * ncldtem + 1
            do i=1,ncldtem
               bitc(i) = icl(i) .le. l
               if (bitc(i)) ozcd(l1+i-1) = ozcd(l0+i-1)
            enddo
         ENDDO
      ENDIF


      DO I=1,ncldtem
         TAUT(I) = 0.
         gwt(I) = 0.
      ENDDO

      DO L=1,nLMP1
         L0 = (L-1) * ncldtem
         DO I=1,ncldtem
            TAUT(I) = TAUT(I) + TAUC(L0+I)
            gwt(i) = gwt(i) + ggwi(l0+i)*tauc(l0+i)
         ENDDO
      ENDDO

C     COMPUTE CLOUDY SKY REFLECTIVITIES                                 
C     CLOUDY SKY OZONE REFLECTION, TAURAY=0.0, GCLD=0.85

      DO I=1,ncldtem
         TLIM(I) = 1. / (1. + 0.1299 * TAUT(I))

         e1(i) = exp(-(0.2775 * TAUT(I) * CSMCLD(I)))
         TR2(I)  = E1(I)
         C1(I)   = 2. - (3. * cmuc(i))
         B1(I)   = 2. + (3. * cmuc(i))
         AA1(I)   = (b1(i) + c1(i) * e1(i)) / (4. + 0.45 * TAUT(I))
         UPIM(I) = 1. - AA1(I)
         DNIM(I) = AA1(I) - e1(i)
         RC1(I)  = UPIM(I) + (E1(I) * RSVCD(I) +
     *      DNIM(I) * AGVCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGVCD(I))
         RC2(I)  = UPIM(I) + (E1(I) * RSNCD(I) +
     *      DNIM(I) * AGNCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGNCD(I))

C     CLOUDY SKY OZONE REFLECTION, TAURAY=0.85, GCLD=0.85

         TAUI(I) = TAUT(I) + 0.85
         G(I) = GWT(I) / TAUI(I)
         TLIM(I) = 1. / (1. + 0.866 *
     *      (1. - G(I)) * TAUI(I))
         ARG1(I) = (1. - G(I) * G(I)) *
     *      TAUI(I) * CSMCLD(I)

         e1(i) = exp(- arg1(i))
         AA1(I)   = (B1(I) + C1(I) * E1(I)) /
     *      (4. + 3. * (1. - g(i)) * taui(i))
         UPIM(I) = 1. - AA1(I)
         DNIM(I) = AA1(I) - E1(I)
         RCO(I)  = tthrd * rc1(i) + (athrd *
     *      (UPIM(I) + (E1(I) * RSVCD(I) +
     *      DNIM(I) * AGVCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGVCD(I))))

C     CLOUDY SKY GROUND REFLECTION, TAURAY=0.15746, GCLD=0.85

         TAUI(I) = TAUT(I) + 0.15746
         G(I)    = GWT(I) / TAUI(I)
         TLIM(I) = 1. / (1. + 0.866 *
     *      (1. - G(I)) * TAUI(I))
         ARG1(I) = (1. - G(I) * G(I)) *
     *      TAUI(I) * CSMCLD(I)

         e1(i) = exp(-arg1(i))
         TR3(I)  = E1(I)
         AA1(I)   = (b1(i) + c1(i) * e1(i)) / (4. + 3. * (1. - G(I)) *
     *      TAUI(I))
         UPIM(I) = 1. - AA1(I)
         DNIM(I) = AA1(I) - E1(I)
         RCG(I)  = UPIM(I) + (E1(I) * RSVCD(I) +
     *      DNIM(I) * AGVCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGVCD(I))
      ENDDO

      CALL CLOUDY(sqrt3,ggwi,omcld
     *,                 AGVCD,RSVCD,CSMCLD
     *,                 CMUC,SCOSC,SCtem,ACLDtem
     *,                 TAUC,RCO,RCG,OZCD,SWILC
     *,                 RVBCtem,RVDCtem,RNBCtem,RNDCtem
     *,                 RC2,TR2,TR3,RSNCD,AGNCD,DSCLDtem,dscldtemtom
     *,                 NSOL,NCLDtem,NCLMP1,NCLDNP,LITD,dooz
     *,                 len, imnnp, imlmp1, nlmp1)
      endif
      endif

C     BACK TO SOLID ANVILS CASE

      do i=1,nslmp1
         ccutem(i) = 0.0
         if(ccu(i).gt.1.e-7)ccutem(i) = 1.0
         csstem(i) = max(ccutem(i), css(i))
      enddo

      NCLDP1 = NCLD + 1
      NCLMP1 = NCLD * nLMP1
      NCLDNP = NCLD * nNP

      DO L=1,nLMP1
         L1 = L * NSOL + 1
         do i=1,nsol
            bitd(l1+i-1) = icc(i) .ne. nnp
         enddo
      ENDDO

C     COMPRESS OUT CLOUDY GRID POINT VALUES FOR OZONE AMT., WATER AMT.,
C     SCOSZ, ETC.

      j=1
      do i=1,nsolnp
         if (bitd(i)) then
            litd(j) = i
            j = j+1
         endif
      enddo

      do i = 1,ncld
         icl(i) = icc(litd(i))
         cmuc(i) = cmu(litd(i))
         agvcd(i) = agv(litd(i))
         agncd(i) = agn(litd(i))
         rsvcd(i) = rsurfv(litd(i))
         rsncd(i) = rsurfn(litd(i))
         scosc(i) = scosz(litd(i))
         csmcld(i) = cosmag(litd(i))
      enddo
      do i = 1,nclmp1
         swilc(i) = swil(litd(i))
         tauc(i) = eoanv(litd(i))
         ggwi(i) = gwi(litd(i))
         omcld(i) = om(litd(i))
      enddo

      IF (DOOZ) THEN
         do i = 1,ncldnp
            ozcd(i) = ozale(litd(i))
         enddo

C        MAKE OZONE AMOUNT CONSTANT BELOW CLOUD TOP

         DO L=1,nLMP1
            L0 = (L-1) * NCLD + 1
            L1 = L * NCLD + 1
            do i=1,ncld
               bitc(i) = icl(i) .le. l
               if (bitc(i)) ozcd(l1+i-1) = ozcd(l0+i-1)
            enddo
         ENDDO
      ENDIF

      DO I=1,NCLD
         TAUT(I) = 0.
         gwt(I) = 0.
      ENDDO

      DO L=1,nLMP1
         L0 = (L-1) * NCLD
         DO I=1,NCLD
            TAUT(I) = TAUT(I) + TAUC(L0+I)
            gwt(I) = gwt(I) + ggwi(l0+i)*TAUC(L0+I)
         ENDDO
      ENDDO

C     COMPUTE CLOUDY SKY REFLECTIVITIES                                 
C     CLOUDY SKY OZONE REFLECTION, TAURAY=0.0, GCLD=0.85

      DO I=1,NCLD
         TLIM(I) = 1. / (1. + 0.1299 * TAUT(I))

         e1(i) = exp(-(0.2775 * TAUT(I) * CSMCLD(I)))
         TR2(I)  = E1(I)
         C1(I)   = 2. - (3. * cmuc(i))
         B1(I)   = 2. + (3. * cmuc(i))
         AA1(I)   = (b1(i) + c1(i) * e1(i)) / (4. + 0.45 * TAUT(I))
         UPIM(I) = 1. - AA1(I)
         DNIM(I) = AA1(I) - e1(i)
         RC1(I)  = UPIM(I) + (E1(I) * RSVCD(I) +
     *      DNIM(I) * AGVCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGVCD(I))
         RC2(I)  = UPIM(I) + (E1(I) * RSNCD(I) +
     *      DNIM(I) * AGNCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGNCD(I))

C     CLOUDY SKY OZONE REFLECTION, TAURAY=0.85, GCLD=0.85

         TAUI(I) = TAUT(I) + 0.85
         G(I) = gwT(I) / TAUI(I)
         TLIM(I) = 1. / (1. + 0.866 *
     *      (1. - G(I)) * TAUI(I))
         ARG1(I) = (1. - G(I) * G(I)) *
     *      TAUI(I) * CSMCLD(I)

         e1(i) = exp(- arg1(i))
         AA1(I)   = (B1(I) + C1(I) * E1(I)) /
     *      (4. + 3. * (1. - g(i)) * taui(i))
         UPIM(I) = 1. - AA1(I)
         DNIM(I) = AA1(I) - E1(I)
         RCO(I)  = tthrd * rc1(i) + (athrd *
     *      (UPIM(I) + (E1(I) * RSVCD(I) +
     *      DNIM(I) * AGVCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGVCD(I))))

C     CLOUDY SKY GROUND REFLECTION, TAURAY=0.15746, GCLD=0.85

         TAUI(I) = TAUT(I) + 0.15746
         G(I)    = gwt(I) / TAUI(I)
         TLIM(I) = 1. / (1. + 0.866 *
     *      (1. - G(I)) * TAUI(I))
         ARG1(I) = (1. - G(I) * G(I)) *
     *      TAUI(I) * CSMCLD(I)

         e1(i) = exp(-arg1(i))
         TR3(I)  = E1(I)
         AA1(I)   = (b1(i) + c1(i) * e1(i)) / (4. + 3. * (1. - G(I)) *
     *      TAUI(I))
         UPIM(I) = 1. - AA1(I)
         DNIM(I) = AA1(I) - E1(I)
         RCG(I)  = UPIM(I) + (E1(I) * RSVCD(I) +
     *      DNIM(I) * AGVCD(I)) * TLIM(I) /
     *      (1. - (1. - TLIM(I)) * AGVCD(I))
      ENDDO

      CALL CLOUDY(sqrt3,ggwi,omcld
     *,                 AGVCD,RSVCD,CSMCLD
     *,                 CMUC,SCOSC,SC,ACLD
     *,                 TAUC,RCO,RCG,OZCD,SWILC
     *,                 RVBC,RVDC,RNBC,RNDC
     *,                 RC2,TR2,TR3,RSNCD,AGNCD,DSCLD,dscldtom
     *,                 NSOL,NCLD,NCLMP1,NCLDNP,LITD,dooz
     *,                 len, imnnp, imlmp1, nlmp1)

 
      if(fracanv) then
      do i = 1,nsol
        anvfrac(i) = 0.0
      enddo

      do l = 1,nlmp1
        do i = 1,nsol
          anvfrac(i) = max(anvfrac(i),ccu(i+nsol*(l-1)) )
        enddo
      enddo
        
      do i = 1,nsol
        coanfrac(i) = 1. - anvfrac(i)
        sc(i) = anvfrac(i)*sc(i) + coanfrac(i)*sctem(i)
        dscld(i) = anvfrac(i)*dscld(i) + coanfrac(i)*dscldtem(i)
        dscldtom(i) = anvfrac(i)*dscldtom(i) + 
     *                  coanfrac(i)*dscldtemtom(i)
        rvdc(i) = anvfrac(i)*rvdc(i) + coanfrac(i)*rvdctem(i)
        rvbc(i) = anvfrac(i)*rvbc(i) + coanfrac(i)*rvbctem(i)
        rndc(i) = anvfrac(i)*rndc(i) + coanfrac(i)*rndctem(i)
        rnbc(i) = anvfrac(i)*rnbc(i) + coanfrac(i)*rnbctem(i)
      enddo

      do l = 1,nlmp1
        do i = 1,nsol
          il = i + (l-1)*nsol
          acld(il) = anvfrac(i)*acld(il)+coanfrac(i)*acldtem(il)
        enddo
      enddo

      endif

      RETURN
      END

