      sUBROUTINE VMFCAL(PR0,RIBC,VKRMN,DELTA,GRAV
     *,                SH,PS,z0           
     *,                SPDM,SHA,ZB,ROS,CU,THVGM,RIB     
     *,                USTAR,VENTMF,THM, tha
     *,                cni, cuni, ctni, ctni3, cti, cui
     *,                len, thgeff, shgeff, tke, ct, dotkef )                               

      use kinds

      IMPLICIT none
C                                                                       
C***  VENTILATION MASS FLUX, BASED ON DEARDORFF, MWR, 1972              
C                                                                       
      integer (kind=int_kind), intent(in) ::
     *     len
      logical (kind=log_kind), intent(in) ::
     *     dotkef
      REAL (kind=dbl_kind), intent(in) ::
     *     pr0, ribc, vkrmn, delta, grav   
 
      REAL (kind=dbl_kind), intent(in), dimension(len) ::            
     *     z0, ZB, ROS, SH, PS      
     *,    THM, SHA, SPDM
     *,    tha, thgeff, shgeff, tke

      REAL (kind=dbl_kind), intent(out), dimension(len) ::            
     *     CU, THVGM, RIB, CNI  
     *,    CUNI, USTAR, CTNI
     *,    CUI, CTI, CT 
     *,    VENTMF, CTNI3 

c     local variables
      REAL (kind=dbl_kind), dimension(len) ::            
     *     TEMV, ZDRDRF, CHOKE, wgm, THGM 
      REAL (kind=dbl_kind) ::            
     *     ribmax, vkrinv, athird, sqrtke
      integer (kind=int_kind) ::            
     *     i          
C                                                                       
         RIBMAX = 0.9*RIBC                                              
         VKRINV = 1.0/VKRMN                                             
         ATHIRD = 1.0_dbl_kind/3.0 _dbl_kind             
C                                                                       
      DO 10 I=1,len                                                    
         WGM(i)  = SHA(i) - SH(i)                                      
C                                                                       
C        SFC-AIR DEFICITS OF MOISTURE AND POTENTIAL TEMPERATURE         
C        WGM IS THE EFFECTIVE SFC-AIR TOTAL MIXING RATIO DIFFERENCE.    
C                                                                       
         THGM(i)  = THA(i)  - THM(i)                                   
   10 CONTINUE                                                          
      if (dotkef) then
         do i = 1,len
            thvgm(i) = (thgeff(i)-thm(i)) + thgeff(i) * delta *
     *                  ((shgeff(i)-sh(i)))
         enddo
      else
         do i = 1,len
            THVGM(i) = THGM(i) + THA(i) * DELTA *
     *                             WGM(i)                  
         enddo
      endif
C                                                                       
C        CUNI AND CTN1 ARE INVERSES OF THE NEUTRAL TRANSFER COEFFICIENTS
C        DEARDORFF EQS(33) AND (34).                                    
C        PR0 IS THE TURBULENT PRANDTL NUMBER AT NEUTRAL STABILITY.      
C                                                                       
C                                                                       
         DO 20 I=1,len
         CNI(i) = 0.025*ZB(i)/z0(i)                          
	 cni(i) = log(cni(i))                                                 
         CNI(i)  = CNI(i)  * VKRINV                                     
         CUNI(i) = CNI(i)  + 8.4_dbl_kind             
         CTNI(i) = CNI(i)  * PR0 + 7.3_dbl_kind
         CTNI3(i)= 0.3_dbl_kind     * CTNI(i)          
         CNI(i)  = GRAV    * ZB(i)                          
C                                                                       
C        SURFACE TO AIR DIFFERENCE OF POTENTIAL TEMPERATURE.            
C        RIB IS THE BULK RICHARDSON NUMBER, DEARDORFF EQ (25)           
C                                                                       
         TEMV(i) = THA(i) * SPDM(i) * SPDM(i)                          
         temv(i) = max(0.000001_dbl_kind,temv(i))
   20    CONTINUE                                                       
      if (dotkef) then
         DO I=1,len                                                    
            rib(i) = -thvgm(i)*grav*zb(i)/(thgeff(i)*tke(i)) 
         enddo
      else
         DO I=1,len                                                    
            RIB(I) = -THVGM(I) * CNI(I) / TEMV(i) 
         enddo
      endif                            
C   
C                                                                       
      if (dotkef) then
         DO I=1,len 
            if(rib(i).ge.0.0_dbl_kind) then  
               cu(i) = ((-0.0307*rib(i)**2)/(61.5+rib(i)**2))+0.044
               ct(i) = ((-0.0152*rib(i)**2)/(190.4+rib(i)**2))+0.025
            else
               cu(i) = ((-0.016*rib(i)**2)/(4.2e4+rib(i)**2))+0.044
               ct(i) = ((-0.0195*rib(i)**2)/(2.1e4+rib(i)**2))+0.025
            endif
         enddo
         DO I=1,len 
            sqrtke = sqrt(tke(i))
            USTAR(I) = sqrt(sqrtke*spdm(I)*CU(I))                                          
            VENTMF(I)=ROS(I)*CT(I)*sqrtke                                   
         enddo
      else
         DO 60 I=1,len 
            if(rib(i).ge.0.0_dbl_kind) then          
C                                                                       
C        THE STABLE CASE. RIB IS USED WITH AN UPPER LIMIT               
C                                                                       
               CHOKE(i)=1.0-MIN(RIB(I),RIBMAX)/RIBC                           
               CU(I)=CHOKE(i)/CUNI(I)                                         
               CT(I)=CHOKE(i)/CTNI(I)   
            else                                  
C                                                                       
C        FIRST, THE UNSTABLE CASE. DEARDORFF EQS(28), (29), AND (30)    
C                                                                       
               ZDRDRF(i) = LOG10(-RIB(I)) - 3.5                             
               CUI(I)    = CUNI(I) - 25.0 * EXP(0.26 * ZDRDRF(i)           
     *                - 0.03 * ZDRDRF(i) * ZDRDRF(i))                    
               CTI(I)    = CUI(I) + CTNI(I) - CUNI(I)                         
               CU(I)     = 1.0 / MAX(CUI(I),0.5 * CUNI(I))                   
               CT(I)     = 1.0 / MAX(CTI(I),CTNI3(I))                        
            END IF    
   60    CONTINUE 
         DO 80 I=1,len                                                   
            USTAR(i) =SPDM(i)*CU(i)                                          
            VENTMF(i)=ROS(i)*CT(i)*USTAR(i)                                   
   80    CONTINUE                                                          
      endif
                                                      
C                                                                       
C     CHECK THAT VENTFC EXCEEDS TOWNSENDS(1962) FREE CONVECTION VALUE, 
C     DEARDORFF EQ(40B)                                                 
C  
      if (.not.dotkef) then
         DO 90 I=1,len 
            if( rib(i).lt.0.0_dbl_kind) then
               if( cti(i).lt.ctni3(i) )                                           
     *            VENTMF(I)=MAX(VENTMF(I),                                       
     *                      ROS(I)*0.00186*(THVGM(I))**ATHIRD) 
            endif                
   90    CONTINUE             
      endif                                          
      RETURN                                                            
C                                                                       
      END                                                               
