      SUBROUTINE VMFCAL2(PR0,RIBC,VKRMN,DELTA,GRAV
     *,                SH,PS,z0           
     *,                SPDM,SHA,ZB,ROS,CU,RA,THVGM,RIB     
     *,                USTAR,VENTMF,THM, tha
     *,                cni, cuni, ctni, ctni3,cti, cui
     *,                len, thgeff, shgeff, tke, ct, dotkef )                               
      use kinds

      IMPLICIT none
C                                                                       
C***  VENTILATION MASS FLUX, BASED ON DEARDORFF, MWR, 1972              
C                          
      integer (kind=int_kind), intent(in) ::
     *     len
      logical (kind=log_kind), intent(in) ::
     *      dotkef
      REAL (kind=dbl_kind), intent(in) ::
     *     pr0, ribc, vkrmn, delta, grav   

      REAL (kind=dbl_kind), intent(in), dimension(len) ::            
     *     z0, ZB, ROS, SH, PS      
     *,    THM, SHA, SPDM
     *,    tha, thgeff, shgeff, tke

      REAL (kind=dbl_kind), intent(out), dimension(len) ::            
     *     CU, THVGM, RIB
     *,    USTAR
     *,    CUI, CTI, CT 
     *,    VENTMF, ra
      REAL (kind=dbl_kind), intent(inout), dimension(len) ::            
     *     cni, cuni, ctni, ctni3


c     local variables
      REAL (kind=dbl_kind), dimension(len) ::            
     *     TEMV, ZDRDRF, CHOKE, wgm, thgm 
      REAL (kind=dbl_kind) ::            
     *     ribmax, vkrinv, athird, sqrtke
      integer (kind=int_kind) ::            
     *     i          
C                                                                       
         RIBMAX = 0.9*RIBC                                              
         VKRINV = 1.0/VKRMN                                             
         ATHIRD = 1.0/3.0                                               
C                                                                       
      DO I=1,len                                                    
         WGM(i)  = SHA(i) - SH(i)                                      
C                                                                       
C        SFC-AIR DEFICITS OF MOISTURE AND POTENTIAL TEMPERATURE         
C        WGM IS THE EFFECTIVE SFC-AIR TOTAL MIXING RATIO DIFFERENCE.    
C                                                                       
         THGM(i)  = THA(i)  - THM(i)                                   
      enddo                                                          
      if (dotkef) then
         do i = 1,len
            thvgm(i) = (thgeff(i)-thm(i)) + thgeff(i) * delta *
     *                  ((shgeff(i)-sh(i)))
         enddo
      else
         do i = 1,len
            THVGM(i) = THGM(i) + THA(i) * DELTA *
     *                             WGM(i)                  
         enddo
      endif
C                                                                       
C        CUNI AND CTN1 ARE INVERSES OF THE NEUTRAL TRANSFER COEFFICIENTS
C        DEARDORFF EQS(33) AND (34).                                    
C        PR0 IS THE TURBULENT PRANDTL NUMBER AT NEUTRAL STABILITY.      
C                                                                       
C                                                                       
C                                                                       
C        SURFACE TO AIR DIFFERENCE OF POTENTIAL TEMPERATURE.            
C        RIB IS THE BULK RICHARDSON NUMBER, DEARDORFF EQ (25)           
C                                                                       
      DO I=1,len                                                    
         TEMV(I) = THA(i) * SPDM(i) * SPDM(i)                          
         temv(i) = max(0.000001_dbl_kind,temv(i))
      enddo   
                         
      if (dotkef) then
         DO I=1,len                                                    
            rib(i) = -thvgm(i)*grav*zb(i)/(thgeff(i)*tke(i)) 
         enddo
      else
         DO I=1,len                                                    
            RIB(I) = -THVGM(I) * CNI(I) / TEMV(i) 
         enddo
      endif                            
C   
C                                                                       
C                                                                       
C        THE STABLE CASE. RIB IS USED WITH AN UPPER LIMIT               
C                                                                       
      if (dotkef) then
         DO I=1,len 
            if(rib(i).ge.0.0_dbl_kind) then                                           
               cu(i) = ((-0.0307*rib(i)**2)/(61.5+rib(i)**2))+0.044
               ct(i) = ((-0.0152*rib(i)**2)/(190.4+rib(i)**2))+0.025
            else
               cu(i) = ((-0.016*rib(i)**2)/(4.2e4+rib(i)**2))+0.044
               ct(i) = ((-0.0195*rib(i)**2)/(2.1e4+rib(i)**2))+0.025
            endif
         enddo
         DO I=1,len 
            sqrtke = sqrt(tke(i))
            USTAR(I) = sqrt(sqrtke*spdm(I)*CU(I))                                          
            VENTMF(I)=ROS(I)*CT(I)*sqrtke                                   
            RA(I)    = ROS(i) / VENTMF(i)                              
         enddo
      else
         DO 60 I=1,len 
            if(rib(i).ge.0.0_dbl_kind) then                                           
C                                                                       
C        THE STABLE CASE. RIB IS USED WITH AN UPPER LIMIT               
C                                                                       
               CHOKE(i)=1.0-MIN(RIB(I),RIBMAX)/RIBC                           
               CU(I)=CHOKE(i)/CUNI(I)                                         
               CT(I)=CHOKE(i)/CTNI(I)   
            else                                  
C                                                                       
C        FIRST, THE UNSTABLE CASE. DEARDORFF EQS(28), (29), AND (30)    
C                                                                       
               ZDRDRF(i) = LOG10(-RIB(I)) - 3.5                             
               CUI(I)    = CUNI(I) - 25.0 * EXP(0.26 * ZDRDRF(i)           
     *                - 0.03 * ZDRDRF(i) * ZDRDRF(i))                    
               CTI(I)    = CUI(I) + CTNI(I) - CUNI(I)                         
               CU(I)     = 1.0 / MAX(CUI(I),0.5 * CUNI(I))                   
               CT(I)     = 1.0 / MAX(CTI(I),CTNI3(I))                        
            END IF    
   60    CONTINUE 
         DO 80 I=1,len                                                   
            USTAR(i) =SPDM(i)*CU(i)                                          
            VENTMF(i)=ROS(i)*CT(i)*USTAR(i)                                   
   80    CONTINUE                                                          
C                                                                       
C     CHECK THAT VENTFC EXCEEDS TOWNSENDS(1962) FREE CONVECTION VALUE, 
C     DEARDORFF EQ(40B)                                                 
C  
      DO 90 I=1,len 
         if( rib(i).lt.0.0_dbl_kind ) then
            if( cti(i).lt.ctni3(i) )                                           
     *         VENTMF(i)=MAX(VENTMF(i),                                       
     *            ROS(i)*0.00186*(THVGM(i))**ATHIRD)  
         endif               
   90 CONTINUE                                                       
C                                                                       
C     AERODYNAMIC RESISTANCE                                            
C                                                                       
         DO 100 I=1,len                                              
            RA(I)    = ROS(i) / VENTMF(i)                              
  100    CONTINUE                                                       
      endif

      RETURN                                                            
C                                                                       
      END                                                               
