      SUBROUTINE VMFCALo(PR0,RIBC,VKRMN,GRAV
     *,                SPDM,ZB,ROS,CU,THVGM     
     *,                USTAR, tha
     *,                len, thgeff, tke, dotkef )                               

      use kinds

      IMPLICIT none
C subroutine is stripped from vmfcal.F and is used only to calculate
c   ustart and cu for oceanic values of the surface roughness length
C                                                                       
C***  VENTILATION MASS FLUX, BASED ON DEARDORFF, MWR, 1972              
C                                                                       
      integer (kind=int_kind), intent(in) ::
     *     len
      logical (kind=log_kind), intent(in) ::
     *      dotkef
      REAL (kind=dbl_kind), intent(in) ::
     *     pr0, ribc, vkrmn, grav   
 
      REAL (kind=dbl_kind), dimension(len), intent(in) ::
     *     ZB,ROS     
     *,    THVGM 
     *,    SPDM
     *,    tha, thgeff,tke
      REAL (kind=dbl_kind), dimension(len), intent(out) ::
     *     CU     
     *,    USTAR

c     local variables
      REAL (kind=dbl_kind), dimension(len) ::            
     *     TEMV, ZDRDRF, CHOKE, cui, cuni, cni, rib 
      REAL (kind=dbl_kind) ::            
     *     ribmax, vkrinv, sqrtke
      integer (kind=int_kind) ::            
     *     i          
C                                                                       
         RIBMAX = 0.9*RIBC                                              
         VKRINV = 1.0/VKRMN                                             
C                                                                       
C        CUNI AND CTN1 ARE INVERSES OF THE NEUTRAL TRANSFER COEFFICIENTS
C        DEARDORFF EQS(33) AND (34).                                    
C        PR0 IS THE TURBULENT PRANDTL NUMBER AT NEUTRAL STABILITY.      
C                                                                       
         DO 20 I=1,len
         CNI(i) = 0.025*ZB(i)/0.0002    ! oceanic surface roughness length                          
	 cni(i) = log(cni(i))                                                 
         CNI(i)  = CNI(i)  * VKRINV                                     
         CUNI(i) = CNI(i)  + 8.4                                        
         CNI(i)  = GRAV    * ZB(i)                          
C                                                                       
C        SURFACE TO AIR DIFFERENCE OF POTENTIAL TEMPERATURE.            
C        RIB IS THE BULK RICHARDSON NUMBER, DEARDORFF EQ (25)           
C                                                                       
   20    CONTINUE                                                       
      if (dotkef) then
         DO I=1,len                                                    
            rib(i) = -thvgm(i)*grav*zb(i)/(thgeff(i)*tke(i)) 
         enddo
         DO I=1,len 
            if(rib(i).ge.0.0_dbl_kind) then                
               cu(i) = ((-0.0307*rib(i)**2)/(61.5+rib(i)**2))+0.044
            else
               cu(i) = ((-0.016*rib(i)**2)/(4.2e4+rib(i)**2))+0.044
            endif
         enddo
         DO I=1,len 
            sqrtke = sqrt(tke(i))
            USTAR(I) = sqrt(sqrtke*spdm(I)*CU(I))                                          
         enddo
      else
         DO I=1,len                                                    
            TEMV(i) = THA(i) * SPDM(i) * SPDM(i)                          
            temv(i) = max(0.000001_dbl_kind,temv(i))
            RIB(I) = -THVGM(I) * CNI(I) / TEMV(i) 
         enddo
         DO 60 I=1,len 
            if(rib(i).ge.0.0_dbl_kind) then                                           
C                                                                       
C        THE STABLE CASE. RIB IS USED WITH AN UPPER LIMIT               
C                                                                       
               CHOKE(i)=1.0-MIN(RIB(I),RIBMAX)/RIBC                           
               CU(I)=CHOKE(i)/CUNI(I)                                         
            else                                  
C                                                                       
C        FIRST, THE UNSTABLE CASE. DEARDORFF EQS(28), (29), AND (30)    
C                                                                       
               ZDRDRF(i) = LOG10(-RIB(I)) - 3.5                             
               CUI(I)    = CUNI(I) - 25.0 * EXP(0.26 * ZDRDRF(i)           
     *                - 0.03 * ZDRDRF(i) * ZDRDRF(i))                    
               CU(I)     = 1.0 / MAX(CUI(I),0.5 * CUNI(I))                   
            END IF    
   60    CONTINUE 
         DO 80 I=1,len                                                   
            USTAR(i) =SPDM(i)*CU(i)                                          
   80    CONTINUE                                                          
      endif                            
C   
      RETURN                                                            
      END                                                               
