! CVS:  $Id: rad_pscales.F,v 1.1 2003/09/03 17:27:59 laura Exp $
! CVS:  $Name:  $

!------------------------------------------------------------------------

      subroutine pscales
     +              (ncol , nlm , ppl , pkd
     +,               ip1 , ip2
     +              )

      use kinds

      implicit none

!------------------------------------------------------------------------
! REFERENCES:
! PSCALES is used to scale pressure for use in the solar k-distribution
! routine.
! Phil Partain/graben (09-15-99).
 
! send comments to partain@atmos.colostate.edu.

! MODIFICATIONS:
! * changed declarations to adapt the code from BUGS4 to BUGS5.
!   Laura D. Fowler/slikrock (02-01-00).

! SUBROUTINES CALLED:
!     none

! FUNCTIONS CALLED:
!     none.

! INCLUDED COMMONS:
!     none.

! ARGUMENT LIST VARIABLES:
!     INPUT ARGUMENTS:
!     ----------------
      integer (kind=int_kind), intent(in)::
     &  ncol !Length of sub-domain.
     &, nlm  !Number of layers.
     
      real (kind=dbl_kind), intent(in), dimension(ncol,nlm)::
     &  ppl  !Pressure          (hPa).

!     OUTPUT ARGUMENTS:
!     -----------------
      integer (kind=int_kind), intent(out), dimension(ncol,nlm)::
     &  ip1  !pointer.
     &, ip2  !pointer.
     
      real (kind=dbl_kind), intent(out), dimension(ncol,nlm)::
     &  pkd  !Weighted pressure (hPa).

! LOCAL VARIABLES:

      integer (kind=int_kind)::
     &  i1, icol, l

      real (kind=dbl_kind), dimension(11)::
     &  stanp

      data stanp / 10.0, 15.8, 25.1, 39.8, 63.1, 100.0,
     +               158.0, 251.0, 398.0, 631.0, 1000.0 /

!-----------------------------------------------------------------------

      do icol = 1, ncol
         i1 = 1
         do l = 1, nlm
            if ( ppl(icol,l) .lt. stanp(1) ) then
               pkd(icol,l) = ppl(icol,l) / stanp(1)
               ip1(icol,l) = 1
               ip2(icol,l) = 1
            elseif ( ppl(icol,l) .ge. stanp(11) ) then
               pkd(icol,l) = (ppl(icol,l) - stanp(10))
     +                     / (stanp(11) - stanp(10))
               ip1(icol,l) = 10
               ip2(icol,l) = 11
            else
30             continue
               if ( ppl(icol,l) .ge. stanp(i1) ) goto 20
               pkd(icol,l) = (ppl(icol,l)-stanp(i1-1))
     +                     / (stanp(i1)-stanp(i1-1))
               ip1(icol,l) = i1-1
               ip2(icol,l) = i1
               goto 5
20             i1 = i1 + 1
               goto 30
            endif
5       enddo
      enddo

      return
      end subroutine pscales

!-----------------------------------------------------------------------
