! CVS:  $Id: rad_qopch4.F,v 1.1 2003/09/03 17:34:10 laura Exp $
! CVS:  $Name:  $

!-----------------------------------------------------------------------

      subroutine qopch4
     +              (ncol , nlm , fkg , dp
     +,                tg
     +              )
      
      use kinds

      implicit none

!-----------------------------------------------------------------------
! REFERENCES:
! Cleaned up version of qopch4.f from G. Stephens. Absorption of CH4
! in the 1400-1250cm^-1 and 1250-1100cm^-1  LW spectral intervals.
! Laura D. Fowler (slikrock. 08-19-97).

! send comments to laura@slikrock.atmos.colostate.edu and
! partain@atmos.colostate.edu.

! MODIFICATIONS:
! * changed declarations to adapt the code from BUGS4 to BUGS5.
!   Laura D. Fowler/slikrock (02-01-00).

! SUBROUTINES CALLED:
!     none.

! FUNCTIONS CALLED:
!     none.

! INCLUDED COMMONS:
!     none.

! ARGUMENT LIST VARIABLES:
!     INPUT ARGUMENTS:
!     ----------------
      integer (kind=int_kind), intent(in)::
     &  ncol !Length of sub-domain.
     &, nlm  !Number of layers.
     
      real (kind=dbl_kind), intent(in), dimension(ncol,nlm)::
     &  dp   !Layer Thickness                       (hPa).
     &, fkg  !Gaseous absorption coefficients (cm-atm)^-1.
     
!     OUTPUT ARGUMENTS:
!     -----------------
      real (kind=dbl_kind), intent(out), dimension(ncol,nlm)::
     &  tg   !Transmission (-).
     
! LOCAL VARIABLES:

      integer (kind=int_kind)
     &  i, l

!-----------------------------------------------------------------------

!---- Note: 1.26238e-3 = 2.24e4/M*10.0/9.8*1.6e-6*M/28.97 where M=16
!     for CH4.
      do l = 1, nlm
         do i = 1, ncol
	    tg(i,l) = fkg(i,l)*dp(i,l)*1.26238e-3
         enddo
      enddo

      return
      end subroutine qopch4

!----------------------------------------------------------------------
