! CVS:  $Id: rad_qoph2o.F,v 1.1 2003/09/03 17:39:32 laura Exp $
! CVS:  $Name:  $

!-----------------------------------------------------------------------

      subroutine qoph2o
     +              (ncol , nlm , fkg , dp
     +,              rmix ,  tg
     +              )

      use kinds

      implicit none

!-----------------------------------------------------------------------
! REFERENCES:
! Cleaned up version of qoph2o.f from G. Stephens. Absorption of H2O
! in each SW and LW spectral interval.
! Laura D. Fowler (slikrock. 08-19-97).

! send comments to laura@slikrock.atmos.colostate.edu and
! partain@atmos.colostate.edu.

! MODIFICATIONS:
! * changed declarations to adapt the code from BUGS4 to BUGS5.
!   Laura D. Fowler/slikrock (02-01-00).

! SUBROUTINES CALLED:
!     none.

! FUNCTIONS CALLED:
!     none.

! INCLUDED COMMONS:
!     none.

! ARGUMENT LIST VARIABLES:
!     INPUT ARGUMENTS:
!     ----------------
      integer (kind=int_kind), intent(in)::
     &  ncol ! Length of sub-domain.
     &, nlm  ! Number of layers.
     
      real (kind=dbl_kind), intent(in), dimension(ncol,nlm)::
     &  dp   !Layer Thickness                       (hPa).
     &, rmix !Water Vapor Mixing Ratio            (kg/kg).
     &, fkg  !Gaseous absorption coefficients (cm-atm)^-1.
     
!     OUTPUT ARGUMENTS:
!     -----------------
      real (kind=dbl_kind), intent(out), dimension(ncol,nlm)::
     &  tg   !Transmisssion                           (-).
     
! LOCAL VARIABLES:

      integer (kind=int_kind)::
     &  i, l

!-----------------------------------------------------------------------

!---- Note: 1269.841 = 2.24e4/M*10.0/9.8 where M = 18 for H2O.
      do l = 1, nlm
         do i = 1, ncol
	    tg(i,l) = fkg(i,l)*rmix(i,l)*dp(i,l)*1269.841
         enddo
      enddo

      return
      end subroutine qoph2o
      
c-----------------------------------------------------------------------
