! CVS:  $Id: rad_qophc.F,v 1.1 2003/09/03 17:38:25 laura Exp $
! CVS:  $Name:  $

!-----------------------------------------------------------------------

      subroutine qophc(ncol,nlm,fkg,dp,tg)
      
      use kinds

      implicit none

!-----------------------------------------------------------------------
! REFERENCES:
! Cleaned up version of qophc.f from G. Stephens. Overlapping of H2O and
! CO2 bands.
! Laura D. Fowler (slikrock. 08-20-97).

! send comments to laura@slikrock.atmos.colostate.edu and
! partain@atmos.colostate.edu.

! MODIFICATIONS:
! * changed declarations to adapt the code from BUGS4 to BUGS5.
!   Laura D. Fowler/slikrock (02-01-00).

! SUBROUTINES CALLED:
!     none.

! FUNCTIONS CALLED:
!     none.

! INCLUDED COMMONS:
!     none.

! ARGUMENT LIST VARIABLES:
!     INPUT ARGUMENTS:
!     ----------------
      integer (kind=int_kind), intent(in)::
     &  ncol !Length of sub-domain.
     &, nlm  !Number of layers.
     
      real (kind=dbl_kind), intent(in), dimension(ncol,nlm)::
     &  dp   !Layer Thickness                       (hPa).
     &, fkg  !Gaseous absorption coefficients (cm-atm)^-1.
     
!     OUTPUT ARGUMENTS:
!     -----------------
      real (kind=dbl_kind), intent(out), dimension(ncol,nlm)::
     &  tg   !Transmission                            (-).
     
! LOCAL VARIABLES:

      integer (kind=int_kind)::
     &  i, l

!-----------------------------------------------------------------------

      do l = 1, nlm
         do i = 1, ncol
	    tg(i,l) = fkg(i,l)*dp(i,l)
         enddo
      enddo

      return
      end subroutine qophc

!-----------------------------------------------------------------------

