! CVS:  $Id: rad_qopn2o.F,v 1.1 2003/09/03 17:33:08 laura Exp $
! CVS:  $Name:  $

!-----------------------------------------------------------------------

      subroutine qopn2o
     +              (ncol , nlm , fkg , dp
     +,                tg
     +              )
      
      use kinds
      
      implicit none

!-----------------------------------------------------------------------
! REFERENCES:
! Cleaned up version of qopn2o.f from G. Stephens. Absorption of N2O
! in the 1400-1250cm^-1 and 1250-1100cm^-1  LW spectral intervals.
! Laura D. Fowler (slikrock. 08-19-97).

! send comments to laura@slikrock.atmos.colostate.edu and
! partain@atmos.colostate.edu.

! MODIFICATIONS:
! * changed declarations to adapt the code from BUGS4 to BUGS5.
!   Laura D. Fowler/slikrock (02-01-00).

! SUBROUTINES CALLED:
!     none.

! FUNCTIONS CALLED:
!     none.

! INCLUDED COMMONS:
!     none.

! ARGUMENT LIST VARIABLES:
!     INPUT ARGUMENTS:
!     ----------------
      integer (kind=int_kind), intent(in)::
     &  ncol  !Length of sub-domain.
     &, nlm   !Number of layers.
     
      real (kind=dbl_kind), intent(in), dimension(ncol,nlm)::
     &  dp    !Layer Thickness                       (hPa).
     &, fkg   !Gaseous absorption coefficients (cm-atm)^-1.
     
!     OUTPUT ARGUMENTS:
!     -----------------
      real (kind=dbl_kind), intent(out), dimension(ncol,nlm)::
     &  tg   !Transmission                             (-).
     
! LOCAL VARIABLES:
      integer (kind=int_kind)
     &  i, l

!-----------------------------------------------------------------------

!---- Note: 2.20918e-4 = 2.24e4/M*10.0/9.8*0.28e-6*M/28.97 where M=44
!     for N2O.
      do l = 1, nlm
         do i = 1, ncol
	    tg(i,l) = fkg(i,l)*dp(i,l)*2.20918e-4
         enddo
      enddo

      return
      end subroutine qopn2o

!-----------------------------------------------------------------------
