! CVS:  $Id: rad_qopo3i.F,v 1.1 2003/09/03 17:30:08 laura Exp $
! CVS:  $Name:  $

!-----------------------------------------------------------------------

      subroutine qopo3i
     +              ( ncol , nlm , fkg , dp
     +,              o3mix ,  tg
     +              )
      
      use kinds

      implicit none
      
!-----------------------------------------------------------------------
! REFERENCES:
! Cleaned up version of qopo3i.f from G. Stephens. Absorption of O3
! in the infrared band (1100-980 cm^-1).
! Laura D. Fowler (slikrock. 08-18-97).

! send comments to laura@slikrock.atmos.colostate.edu and
! partain@atmos.colostate.edu.

! MODIFICATIONS:
! * changed declarations to adapt the code from BUGS4 to BUGS5.
!   Laura D. Fowler/slikrock (02-01-00).

! SUBROUTINES CALLED:
!     none.

! FUNCTIONS CALLED:
!     none.

! INCLUDED COMMONS:
!     none.

! ARGUMENT LIST VARIABLES:
!     INPUT ARGUMENTS:
!     ----------------
      integer (kind=int_kind), intent(in)::
     &  ncol  !Length of sub-domain.
     &, nlm   !Number of layers.
     
      real (kind=dbl_kind), intent(in), dimension(ncol,nlm)::
     &  dp    !Layer Thickness                       (hPa).
     &, o3mix !Ozone Mixing Ratio                  (kg/kg).
     &, fkg   !Gaseous absorption coefficients (cm-atm)^-1.
     
!     OUTPUT ARGUMENTS:
!     -----------------
      real (kind=dbl_kind), intent(out), dimension(ncol,nlm)::
     &  tg    !Transmission                            (-).
     
! LOCAL VARIABLES:

      integer (kind=int_kind)::
     &  i , l
          
!-----------------------------------------------------------------------

!---- Note: 476.16 = 2.24e4/M*10.0/9.8 where M = 48 for O3.
      do l = 1, nlm
         do i = 1, ncol
 	    tg(i,l) = fkg(i,l)*o3mix(i,l)*dp(i,l)*476.16
         enddo
      enddo

      return
      end subroutine qopo3i
	
!-----------------------------------------------------------------------

