!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

      module domain_decomposition


!***********************************************************************
!
!	this module defines how the horizontal domain is decomposed
!	it also contains mpi specific information
!
!***********************************************************************

!-------------------------------------------------------------------------
!  VARIABLE DEFINITIONS
!
!	iim		= number of cells in i-direction on one panel
!	jjm		= number of cells in j-direction on one panel
!	isdm		= number of blocks in the i-direction on ONE panel
!			  must be an even number
!	jsdm		= number of blocks in the j-direction on ONE panel
!	npe_atmos	= number of processes for AGCM
!	sbdmn_max	= mask number subdomains
!	nsdm		= number of subdomains each process owns
!	ipad		= padding in the i-direction
!	jpad		= padding in the j-direction
!-------------------------------------------------------------------------

      use kinds
      use model_parameters

      implicit none
      save

        integer (kind=int_kind), parameter ::                         &
                        isdm = 1,                                     &
                        jsdm = 1,                                     &
                        npe_atmos = 001,                              &
                        sbdmn_max = isdm*jsdm,                        &
                        nsdm = sbdmn_max/npe_atmos,                   &
                        ipad = 0,                                     &
                        jpad = 0,                                     &
                        iim = 1,                                      &
                        jjm = 1

        integer (kind=int_kind), parameter ::                         &
                        iimjjm = iim * jjm

      integer (kind=int_kind), parameter :: my_task = 0
      integer (kind=int_kind) :: itask = 0

	end module domain_decomposition

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
