!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

        module source_terms

!-----------------------------------------------------------------------
! PURPOSE: computes sources for prognostic equations. examples include
!    del4 diffusion, pbl pleak term, and Held-Suarez forcing

!---- modifications:
!     added initialization of the elqng source terms for the eau_liqng
!     parameterization of fractional cloudiness.
!     Laura D. Fowler/mcbug (09-06-02).

!-----------------------------------------------------------------------

        use kinds
        use physical_parameters
        use model_parameters
        use model_control
        use prognostics
	use tracer_names

#ifdef link_to_gcm_physics
#ifdef cup_friction
	use cumulus_friction
#endif
#endif

#ifdef gravity_wave_drag
	use gravity_wave_drag_module
#endif

#ifdef held_suarez
	use held_suarez_forcing_module
#endif

        implicit none
        save

	public ::
     *		init_sources

!*****************************************************************

        contains

!*****************************************************************

!======================================================================
! BEGINNING OF INIT_SOURCES
!======================================================================
	subroutine init_sources
	implicit none

	u_src = c0
	th_src = c0
	th_res = c0
	tracer_src = c0
	pleak = c0
#ifdef eau_ng
      elqng_src = c0
#endif

	end subroutine init_sources
!======================================================================
! END OF INIT_SOURCES
!======================================================================

	end module source_terms
!||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
